/*
 * Can-Driver for Softing Can-Card
 * Copyright (C) 1994-2003, Softing AG, Gunnar Larisch, Werner Knorsch
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * email: support.automation@softing.com
 * Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany
 */

/**************************************************************/
/*                                                            */
/* Filename  :  DPCOMM.H                                      */
/*                                                            */
/* Funktion  :  Kommunikationsstrukturen etc. beim            */
/*              Laden des Anwendungsprogrammes.               */
/*                                                            */
/* Autor     : Thomas Lang                                    */
/* Datum     : 24.06.94                                       */
/**************************************************************/

/*
 * $Id: Dpcomm.h,v 1.2 2003/10/31 15:16:38 kno Exp $
 */



/***********************************/
/* Offsets bzw. Variablen im DPRAM */
/***********************************/

#define _OfsCommandCode_ 0x7e0L
#define _OfsCommandData_ 0x7e2L

#define _OfsReceiptCode_ 0x7f0L
#define _OfsReceiptData_ 0x7f2L

#define _OfsResetCounter_ 0x7fdL

/****************************/
/* Kommandos und Quittungen */
/****************************/

#define _CommandNone_           0x00
#define _CommandCopyMem_        0x01
#define _CommandFillMem_        0x02
#define _CommandJumpProg_       0x03

#define _CommandStartTest_      0x10


#define _ReceiptNone_           0x00
#define _ReceiptOk_             0x01
#define _ReceiptNotOk_          0x02
#define _ReceiptCommandUnknown_ 0x03

#define _ReceiptTestMsg_        0x10

typedef struct CommandCopyMemStruct
{
    USIGN32 SourceAddrAbs;

    USIGN32 DestinationAddrAbs;
    USIGN16 Len;
    BYTE CalcCS;
}
CommandCopyMemType;

typedef struct CommandFillMemStruct
{
    USIGN32 StartAddrAbs;
    USIGN32 EndAddrAbs;
    BYTE FillByte;
}
CommandFillMemType;

typedef struct CommandJumpProgStruct
{
    USIGN32 EntryPointAbs;
    BYTE AutoRestart;
}
CommandJumpProgType;

typedef struct CommandStartTestStruct
{
    USIGN32 ASCIIParamAddrAbs;
}
CommandStartTestType;

typedef struct ReceiptCopyMemStruct
{
    USIGN16 CS16BitUnsignedAdd;
}
ReceiptCopyMemType;

typedef struct ReceiptTestMsgStruct
{
    USIGN32 ASCIIMsgAddrAbs;
}
ReceiptTestMsgType;



#ifdef CARD
/* Lage des DPRAM's */
#define _DPRAMStartCard_ 0xd0000L

#define _CommandCode_ (volatile USIGN16 far *) (_DPRAMStartCard_+_OfsCommandCode_)
#define _CommandData_ (volatile VOID far *) (_DPRAMStartCard_+_OfsCommandData_)

#define _ReceiptCode_ (volatile USIGN16 far *) (_DPRAMStartCard_+_OfsReceiptCode_)
#define _ReceiptData_ (volatile VOID far *) (_DPRAMStartCard_+_OfsReceiptData_)
#endif

#ifdef HOST
/* Lage des DPRAM's auf der Karte aus der Sicht des DNE5001 */
#define _OffsetDPRAMInCommonMemSpace_ 0x100000L

/* Lage des DPRAM's aus Sicht des C165 */
#define _AbsAddrDPRAMFromCardView_ 0xd0000L



#define _CommandCode_ (volatile USIGN16 far *) ((CAN_ADDRESS)DPRAMPtr+_OfsCommandCode_)
#define _CommandData_ (volatile VOID far *) ((CAN_ADDRESS)DPRAMPtr+_OfsCommandData_)

#define _ReceiptCode_ (volatile USIGN16 far *) ((CAN_ADDRESS)DPRAMPtr+_OfsReceiptCode_)
#define _ReceiptData_ (volatile VOID far *) ((CAN_ADDRESS)DPRAMPtr+_OfsReceiptData_)

#define _ResetCounter_ (volatile BYTE far *) ((CAN_ADDRESS)DPRAMPtr+_OfsResetCounter_)
#endif
