/****************************************************************************/
/*                                                                          */
/*   Softing AG          Richard-Reitzner-Allee 6       85540 Haar          */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/*   Copyright (C) by Softing AG, 1997, All rights reserved.                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/*                               API_TEST . H                               */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* MODULE_DESCRIPTION  special declarations for API test program            */
/* VERSION             0.1                                                  */
/* DATE                20.04.98                                             */
/*                                                                          */
/****************************************************************************/

                                       /* object definition in object list    */
struct obj_structure
{
    /* control byte  for receive object:   */
    /* 0x01 bit - extended (1) or standard */
    /* 0x02 bit - auto remote enabled      */
    /* 0x04 bit - receive interrupt enable */

    /* control byte  for transmit object:  */
    /* 0x01 bit - extended (1) or standard */
    /* 0x02 bit - TransmitAckEnable        */

    unsigned char ctrl;
    unsigned long ID;
};

struct objecti_list
{
    unsigned char NumCAN1_rec_objs;
    unsigned char NumCAN1_xmt_objs;
    unsigned char NumCAN2_rec_objs;
    unsigned char NumCAN2_xmt_objs;
    struct obj_structure CAN1_rec_obj[2048];
    struct obj_structure CAN1_xmt_obj[2048];
    struct obj_structure CAN2_rec_obj[200];
    struct obj_structure CAN2_xmt_obj[200];
    unsigned char CAN1ObjectFilter[200][8];
    unsigned short CAN1nFrames[200];
}
obj_list;

unsigned long old_time;

int TransmitAckEnableFIFO1;
int TransmitAckEnableFIFO2;
char filename[255];


extern int define_interface(char op_mode);
extern void show_interface_settings(char op_mode);
extern int define_objects(int channel, char op_mode);
extern void show_object_list_static(void);
extern void show_object_list_dyn(void);
extern void clear_object_lists(void);
extern int Initialize_dyn_obj_buffer(void);
extern int Initialize_fifo(void);
extern int Initialize_stat_obj_buffer(void);
extern void show_acceptance_filter(void);
#define LINELEN 128
#define ENTRIES 1024
#define BUFFER_MASK (ENTRIES - 1)
#define HANDLE unsigned long
#define getch readch
#define getche readch
