/*
 * Can-Driver for Softing Can-Card
 * Copyright (C) 1994-2003, Softing AG, Gunnar Larisch
 * 
 * See file CREDITS for list of people who contributed to this
 * project.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * email: support.automation@softing.com
 * Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany
 */

/*
 * $Id: can_104.h,v 1.4 2003/10/31 15:16:38 kno Exp $
 */






#ifndef __CAN104_H__
#define __CAN104_H__

#ifndef __KERNEL__
#  define __KERNEL__
#endif
#ifndef MODULE
#  define MODULE
#endif

/******************************************************************
**  macros
*******************************************************************/

#define CAN_NR_PORTS   4          /* use 4 ports by default */
#define CAN_DPRAM_SIZE 0x1000   /* DPRAM size */
#define DRIVERNAME     "vcanacd"  // Driver name


/******************************************************************
**  externals
*******************************************************************/

extern PCDEVICES pcCanDevices;


/******************************************************************
** protoypes  
*******************************************************************/
int can_intDPRAM(PCDEVICES pDevice);
int can_intIOPorts(PCDEVICES pDevice);
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
irqreturn_t can_interrupt(int irq, void *dev_id, struct pt_regs *regs);
#else
    irqreturn_t can_interrupt(int irq, void *dev_id);
#endif
    int canInitFirmwareTest(PCDEVICES pDevice);
int can_init(VOID);
VOID can_cleanup(VOID);

INT32  CanInstallInterrupt(PCDEVICES pDevice);


#endif // __CAN104_H__
