/*
 * Can-Driver for Softing Can-Card
 * Copyright (C) 1994-2003, Softing AG, Gunnar Larisch, Werner Knorsch
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * email: support.automation@softing.com
 * Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany
 */

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* PROJECT_NAME           PCMCIA                                            */
/* MODULE                 CARD_CAN.H                                        */
/* COMPONENT_LIBRARY                                                        */
/*                                                                          */
/* MODULE_DESCRIPTION     header file of CARD_CAN.C                         */
/*                                                                          */
/*HEAD_END*******************************************************************/

/*
 * $Id: can_card.h,v 1.2 2003/10/31 15:16:38 kno Exp $
 */



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define FCT_RESET_CHIP                  0
#define FCT_INITIALIZE_CHIP             1
#define FCT_INITIALIZE_CHIP2            2
#define FCT_SET_MODE                    3
#define FCT_SET_MODE2                   4
#define FCT_SET_OUTPUT_CONTROL          5
#define FCT_SET_OUTPUT_CONTROL2         6
#define FCT_SET_ACCEPTANCE              7
#define FCT_SET_ACCEPTANCE2             8
#define FCT_ECHO_TX_REQ                 9
#define FCT_ECHO_TX_REQ2                10
#define FCT_START_CHIP                  11
#define FCT_GET_VERSION                 12
#define FCT_ENABLE_FIFO_TRANSMIT_ACK    13
#define FCT_ENABLE_FIFO_TRANSMIT_ACK2   14
#define FCT_ENABLE_EMU_CHECK            15
#define FCT_ENABLE_DYN_OBJ_BUF          16
#define FCT_INITIALIZE_INTERFACE        17
#define FCT_DEFINE_OBJECT               18
#define FCT_DEFINE_OBJECT2              19
#define FCT_READ_AC                     20
#define FCT_SEND_REMOTE_OBJECT          21
#define FCT_SEND_REMOTE_OBJECT2         22
#define FCT_SUPPLY_OBJECT_DATA          23
#define FCT_SUPPLY_OBJECT_DATA2         24
#define FCT_SUPPLY_RCV_OBJECT_DATA      25
#define FCT_SUPPLY_RCV_OBJECT_DATA2     26
#define FCT_SEND_OBJECT                 27
#define FCT_SEND_OBJECT2                28
#define FCT_WRITE_OBJECT                29
#define FCT_WRITE_OBJECT2               30
#define FCT_READ_RCV_DATA               31
#define FCT_READ_RCV_DATA2              32
#define FCT_READ_XMT_DATA               33
#define FCT_READ_XMT_DATA2              34
#define FCT_ENABLE_DDE_CHECK            35
#define FCT_ENABLE_FIFO                 36
#define FCT_SET_TIMER_RATE              37
#define FCT_ENABLE_J1939_CHECK          38
#define FCT_DEFINE_CYCLIC               39
#define FCT_DEFINE_CYCLIC2              40
#define FCT_ENABLE_OE_CHECK             41
#define FCT_ENABLE_IVM_CHECK            42
#define FCT_GET_SN                      43
#define FCT_ENABLE_L1_CHECK             47
#define FCT_ENABLE_L2_CHECK             48
#define FCT_SET_L1_LIC                  49
#define FCT_SET_L2_LIC                  50
#define FCT_ENABLE_ERROR_FRAME          51
#define FCT_OBJECT_FILTER               52

#define FCT_INIT_SIGNALS                53
#define FCT_READ_SIGNALS                54
#define FCT_WRITE_SIGNALS               55

#ifdef DTS
#define FCT_READ_RCV_DATA_E             56
#define FCT_READ_RCV_DATA_E2            57
#endif /* DTS */

#define FCT_SET_IRQ_NUM                 58


#define FCT_READ_FIFO_LEVELS            72
#define FCT_RESET_RCV_FIFO        73
#define FCT_RESET_XMT_FIFO        74



#if (defined LICVECT || defined LICSOFT ||defined LICENSE || defined LICCRYPT)
#define FCT_READ_BOARD_IDENT            59
#define FCT_READ_ALL_LICENSE_DATA       60
#define FCT_READ_CAN_LICENSE_DATA       61
#define FCT_WR_LICENSE_BYTE_WORES       62
#define FCT_WR_CAN_LICENSE_BYTE         63
#define FCT_WR_CAN_LICENSE_BIT          64
#define FCT_LICENSE_BOARD           65
#define FCT_GET_LICENSE_DATA        66

#endif /* LICVECT || LICSOFT || LICENSE */

#define FCT_SET_RED_LED_FEATURE         75
#define FCT_SET_GREEN_LED_FEATURE       76


#define FCT_NO_CMD                      99





/*-------------------------*/
/*       structures        */
/*-------------------------*/

                /* typedef of union for bitmask used within new functions */
                /* for the CAN-AC2-PCI-piggyback extension.               */
                /* NOTICE: With plugged piggyback channel 2 no debugging  */
                /* using ASC0-Interface of C165 is possible!              */
#ifdef __BORLANDC__
#pragma warn -bbf
#endif



/*-------------------------*/
/*    externe Variablen    */
/*-------------------------*/

/*-------------------------*/
/*    externe Funktionen   */
/*-------------------------*/
PRAEDECL INT32 MIDDECL CANDR_synch_communication(PCDEVICES pDevice);
#ifdef EMU
PRAEDECL INT32 MIDDECL CANDR_enable_emu_check(USIGN32 code,
                                            PCDEVICES pDevice);
PRAEDECL INT32 MIDDECL CANDR_enable_oe_check(USIGN32 code,
                                           PCDEVICES pDevice);
PRAEDECL INT32 MIDDECL CANDR_enable_l1_check(USIGN32 code,
                                           PCDEVICES pDevice);
PRAEDECL INT32 MIDDECL CANDR_enable_l2_check(USIGN32 code,
                                           PCDEVICES pDevice);
#endif
PRAEDECL INT32 MIDDECL CANDR_enable_ivm_check(USIGN32 code,
                                            PCDEVICES pDevice);


PRAEDECL INT32 MIDDECL CANDR_echo_tx_req(INT32 Echo, PCDEVICES pDevice);
PRAEDECL INT32 MIDDECL CANDR_echo_tx_req2(INT32 Echo, PCDEVICES pDevice);
PRAEDECL INT32 MIDDECL CANDR_set_timer_rate(short timer_rate, short int_always,
                                          PCDEVICES pDevice);
PRAEDECL INT32 MIDDECL CANDRVGetModuleParameters(SCHAR *pathBuff,
                                               INT32 pathBufflen,
                                               SCHAR *timeBuff,
                                               INT32 timeBufflen,
                                               INT32 appHeaderVersion,
                                               PCDEVICES pDevice);

INT32 wait_for_handshake(volatile PUSIGN16 handshake, INT32 timeout_sec,
                       USIGN16 timeout_ms);
VOID LoaderPrintMsgCallBack(SCHAR *);
int_ CANDR_set_irq_number(INT32, PCDEVICES);
int_ CANDR_enable_dde_check(USIGN32, PCDEVICES);
int_ CANDR_enable_j1939_check(USIGN32, PCDEVICES);

int_ CANDR_init_signals(USIGN32 ulChannelDirectionMask,
                        USIGN32 ulChannelOutputDefaults,
                        PCDEVICES pDevice);
int_ CANDR_read_signals(USIGN32 *pulChannelRead, PCDEVICES pDevice);
int_ CANDR_write_signals(USIGN32 ulChannelWrite,
                         USIGN32 ulCareMask, PCDEVICES pDevice);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

INT32 CANDR_reset_board(PCDEVICES pDevice);

/* +--- CANDR_reset_chip         -------------------------------------------*/
INT32 CANDR_reset_chip(PCDEVICES pDevice);


/* +--- CANDR_initialize_chip(2) -------------------------------------------*/
INT32 CANDR_initialize_chip(INT32 presc, INT32 sjw, INT32 tseg1, INT32 tseg2, INT32 sam,
                          PCDEVICES pDevice);

INT32 CANDR_initialize_chip2(INT32 presc, INT32 sjw, INT32 tseg1, INT32 tseg2, INT32 sam,
                           PCDEVICES pDevice);

/* +--- CANDR_set_mode(2)        -------------------------------------------*/
INT32 CANDR_set_mode(INT32 SleepMode, INT32 SpeedMode, PCDEVICES pDevice);

INT32 CANDR_set_mode2(INT32 SleepMode, INT32 SpeedMode, PCDEVICES pDevice);

/* +--- CANDR_set_acceptance(2)  -------------------------------------------*/
INT32 CANDR_set_acceptance(USIGN32 AccCodeStd,
                         USIGN32 AccMaskStd,
                         USIGN32 AccCodeXtd, USIGN32 AccMaskXtd,
                         PCDEVICES pDevice);

INT32 CANDR_set_acceptance2(USIGN32 AccCodeStd,
                          USIGN32 AccMaskStd,
                          USIGN32 AccCodeXtd, USIGN32 AccMaskXtd,
                          PCDEVICES pDevice);

/* +--- CANDR_set_output_control(2)  ---------------------------------------*/
INT32 CANDR_set_output_control(INT32 OutputControl, PCDEVICES pDevice);

INT32 CANDR_set_output_control2(INT32 OutputControl, PCDEVICES pDevice);

/* +--- CANDR_initialize_interface   ---------------------------------------*/

INT32 CANDR_initialize_interface(INT32 ReceiveFifoEnable,
                               INT32 ReceivePollAll,
                               INT32 ReceiveEnableAll,
                               INT32 ReceiveIntEnableAll,
                               INT32 AutoRemoteEnable,
                               INT32 TransmitReqFifoEnable,
                               INT32 TransmitPollAll,
                               INT32 TransmitAckEnableAll,
                               INT32 TransmitAckFifoEnable,
                               INT32 TransmitRmtFifoEnable, PCDEVICES pDevice);

/* +--- CANDR_define_object(2)          ------------------------------------*/

INT32 CANDR_define_object(USIGN32 Handle,
                        INT32 *ObjectNumber,
                        INT32 Type,
                        INT32 ReceiveIntEnable,
                        INT32 AutoRemoteEnable, INT32 TransmitAckEnable,
                        PCDEVICES pDevice);

INT32 CANDR_define_object2(USIGN32 Handle,
                         INT32 *ObjectNumber,
                         INT32 Type,
                         INT32 ReceiveIntEnable,
                         INT32 AutoRemoteEnable, INT32 TransmitAckEnable,
                         PCDEVICES pDevice);

/* +--- CANDR_define_cyclic(2)        --------------------------------------*/

INT32 CANDR_define_cyclic(INT32 ObjectNumber,
                        USIGN32 Rate, USIGN32 Cycles,
                        PCDEVICES pDevice);

INT32 CANDR_define_cyclic2(INT32 ObjectNumber,
                         USIGN32 Rate, USIGN32 Cycles,
                         PCDEVICES pDevice);

/* +--- CANDR_enable_fifo            ---------------------------------------*/

INT32 CANDR_enable_fifo(PCDEVICES pDevice);

/* +--- CANDR_optimize_rcv_speed     ---------------------------------------*/
/* this function has no effect on the CANcard                               */

INT32 CANDR_optimize_rcv_speed(void);

/* +--- CANDR_enable_dyn_obj_buf     ---------------------------------------*/

INT32 CANDR_enable_dyn_obj_buf(PCDEVICES pDevice);

/* +--- CANDR_enable_timestamps      ---------------------------------------*/
/* this function has no effect on the CANcard                               */
#define  CANDR_ET_NO_FIFO                 -6    /* fifo not enabled
                                                   (only CAN-AC2)             */

INT32 CANDR_enable_timestamps(void);
/* +--- CANDR_enable_fifo_transmit_ack  ------------------------------------*/

INT32 CANDR_enable_fifo_transmit_ack(PCDEVICES pDevice);

INT32 CANDR_enable_fifo_transmit_ack2(PCDEVICES pDevice);

/* +--- CANDR_get_version            ---------------------------------------*/
/* the parameter hw_version is not used with the CAN-AC2                    */

INT32 CANDR_get_version(INT32 *sw_version,
                      INT32 *fw_version,
                      INT32 *hw_version, INT32 *license, INT32 *can_chip_type,
                      PCDEVICES pDevice);

INT32 CANDR_get_version_fw(INT32 *sw_version,
                      INT32 *fw_version,
                      INT32 *hw_version, INT32 *license, INT32 *can_chip_type,
                      PCDEVICES pDevice);

/* +--- CANDR_get_serial_number from device data ---------------------------------------*/

INT32 CANDR_get_serial_number(USIGN32 *ser_number, PCDEVICES pDevice);

/* +--- CANDR_get_serial_number from firmware ---------------------------------------*/
INT32 CANDR_get_serial_number_fw(USIGN32 *ser_number, PCDEVICES pDevice);

/* +--- CANDR_start_chip             ---------------------------------------*/

INT32 CANDR_start_chip(PCDEVICES pDevice);

/* +--- CANDR_send_remote_object(2)  ---------------------------------------*/

INT32 CANDR_send_remote_object(INT32 ObjectNumber, INT32 DataLength,
                             PCDEVICES pDevice);

INT32 CANDR_send_remote_object2(INT32 ObjectNumber, INT32 DataLength,
                              PCDEVICES pDevice);

/* +--- CANDR_supply_object_data(2)  ---------------------------------------*/

INT32 CANDR_supply_object_data(INT32 ObjectNumber,
                             INT32 DataLength, USIGN8 *pData,
                             PCDEVICES pDevice);

INT32 CANDR_supply_object_data2(INT32 ObjectNumber,
                              INT32 DataLength, USIGN8 *pData,
                              PCDEVICES pDevice);

/* +--- CANDR_supply_rcv_object_data(2)-------------------------------------*/

INT32 CANDR_supply_rcv_object_data(INT32 ObjectNumber,
                                 INT32 DataLength, USIGN8 *pData,
                                 PCDEVICES pDevice);

INT32 CANDR_supply_rcv_object_data2(INT32 ObjectNumber,
                                  INT32 DataLength, USIGN8 *pData,
                                  PCDEVICES pDevice);

/* +--- CANDR_send_object(2)         ---------------------------------------*/


INT32 CANDR_send_object(INT32 ObjectNumber, INT32 DataLength, PCDEVICES pDevice);

INT32 CANDR_send_object2(INT32 ObjectNumber, INT32 DataLength, PCDEVICES pDevice);

/* +--- CANDR_write_object(2)        ---------------------------------------*/

INT32 CANDR_write_object(INT32 ObjectNumber,
                       INT32 DataLength, USIGN8 *pData,
                       PCDEVICES pDevice);

INT32 CANDR_write_object2(INT32 ObjectNumber,
                        INT32 DataLength, USIGN8 *pData,
                        PCDEVICES pDevice);

/* +--- CANDR_read_rcv_data(2)       ---------------------------------------*/

INT32 CANDR_read_rcv_data(INT32 ObjectNumber,
                        USIGN8 *pRCV_Data, USIGN32 *Time,
                        PCDEVICES pDevice);

INT32 CANDR_read_rcv_data2(INT32 ObjectNumber,
                         USIGN8 *pRCV_Data, USIGN32 *Time,
                         PCDEVICES pDevice);


/* +--- CANDR_read_xmt_data(2)       ---------------------------------------*/

INT32 CANDR_read_xmt_data(INT32 ObjectNumber,
                        INT32 *pDataLength, USIGN8 *pXMT_Data,
                        PCDEVICES pDevice);

INT32 CANDR_read_xmt_data2(INT32 ObjectNumber,
                         INT32 *pDataLength, USIGN8 *pXMT_Data,
                         PCDEVICES pDevice);

/* +--- CANDR_read_ac                ---------------------------------------*/

INT32 CANDR_read_ac(PARAM_STRUCT * param, PCDEVICES pDevice);

/* +--- CANDR_send_data              ---------------------------------------*/
#define  CANDR_SD_FIFO_FULL               -1    /* transmit fifo full         */

INT32 CANDR_send_data(USIGN32 Ident,
                    INT32 Xtd, INT32 DataLength, USIGN8 *pData,
                    PCDEVICES pDevice);

INT32 CANDR_send_data2(USIGN32 Ident,
                     INT32 Xtd, INT32 DataLength, USIGN8 *pData,
                     PCDEVICES pDevice);

/* +--- CANDR_send_remote            ---------------------------------------*/
INT32 CANDR_send_remote(USIGN32 Ident, INT32 Xtd, INT32 DataLength,
                      PCDEVICES pDevice);

INT32 CANDR_send_remote2(USIGN32 Ident, INT32 Xtd, INT32 DataLength,
                       PCDEVICES pDevice);


/* +--- CANDR_get_trigger(2)            ---------------------------------------*/
/* these functions have no effect on the CANcard                               */
INT32 CANDR_get_trigger(INT32 *level, PCDEVICES pDevice);

INT32 CANDR_get_trigger2(INT32 *level, PCDEVICES pDevice);

/* +--- CANDR_set_trigger            ---------------------------------------*/
#define  CANDR_ST_FIFO_FULL               -1    /* transmit fifo full         */

INT32 CANDR_set_trigger(INT32 level, PCDEVICES pDevice);

INT32 CANDR_set_trigger2(INT32 level, PCDEVICES pDevice);

/* +--- CANDR_reinitialize           ---------------------------------------*/
INT32 CANDR_reinitialize(PCDEVICES pDevice);

/* +--- CANDR_get_time               ---------------------------------------*/
INT32 CANDR_get_time(USIGN32 *time, PCDEVICES pDevice);

/* +--- CANDR_get_bus_state          ---------------------------------------*/


INT32 CANDR_get_bus_state(PCDEVICES pDevice);

/* +--- CANDR_reset_rcv_fifo         ---------------------------------------*/
INT32 CANDR_reset_rcv_fifo(PCDEVICES pDevice);

/* +--- CANDR_reset_xmt_fifo         ---------------------------------------*/
INT32 CANDR_reset_xmt_fifo(PCDEVICES pDevice);

/* +--- CANDR_reset_lost_msg_counter  --------------------------------------*/
INT32 CANDR_reset_lost_msg_counter(PCDEVICES pDevice);

/* +--- CANDR_read_rcv_fifo_level    ---------------------------------------*/
/* returns number of items in receive fifo   */
INT32 CANDR_read_rcv_fifo_level(PCDEVICES pDevice);

/* +--- CANDR_read_xmt_fifo_level    ---------------------------------------*/
/* returns number of items in transmit fifo  */
INT32 CANDR_read_xmt_fifo_level(PCDEVICES pDevice);

/* +--- CANDR_set_path               ---------------------------------------*/
INT32 CANDR_set_path(SCHAR * path);

/* +--- INIPC_close_board            ---------------------------------------*/
INT32 INIDR_close_board(PCDEVICES pDevice);


/* +--- CANDR_enable_error_frame_detection  --------------------------------*/
/* this function has no effect on the CAN-AC2                               */
INT32 CANDR_enable_error_frame_detection(PCDEVICES pDevice);

/* +--- CANDR_get_device_id  -----------------------------------------------*/
/* this function has no effect on the CAN-AC2                               */
INT32 CANDR_get_device_id(USIGN32 *pulDeviceId, PCDEVICES pDevice);

/* +--- CANDR_init_signals/CANDR_read_signals/CANDR_write_signals            */
/* these functions are only available on the CANcard. They are designed  */
/* for use with the CANcard and piggy-back boards. These functions are   */
/* not in the standard users manual. For description read the piggy-back     */
/* manuals                                                                   */
INT32 CANDR_init_signals(USIGN32 ulChannelDirectionMask,
                       USIGN32 ulChannelOutputDefaults,
                       PCDEVICES pDevice);

INT32 CANDR_read_signals(USIGN32 *pulChannelRead, PCDEVICES pDevice);

INT32 CANDR_write_signals(USIGN32 pulChannelWrite,
                        USIGN32 ulCareMask, PCDEVICES pDevice);
