/*
 * Can-Driver for Softing Can-Card
 * Copyright (C) 1994-2003, Softing AG, Gunnar Larisch, Werner Knorsch
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * email: support.automation@softing.com
 * Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany
 */

/***************************************************************************/
/*                                                                         */
/*                     C A N _ D E F . H                                   */
/*                                                                         */
/***************************************************************************/
/*                                                                         */
/* PROJECT:            CANLIB                                              */
/*                                                                         */
/* MODULE:             CAN_DEF.H                                           */
/*                                                                         */
/* MODULE_DESCRIPTION  definitions for CAN-LAYER2 LIB                      */
/*                     CANcard and CAN-AC2                                 */
/*                                                                         */
/* USAGE               description of the macro definitions                */
/*                                                                         */
/*       Macro         Description                                         */
/*                                                                         */
/*       WIN16         define for building 16-bit windows (WIN3.11)        */
/*                     applications                                        */
/*                                                                         */
/*       WIN32         define for building 32-bit applications             */
/*                     (WIN-NT 4.0 and WIN 95)                             */
/*                                                                         */
/*       DOS           define for MSDOS applications. DOS is               */
/*                     automatically defined, if neither WIN16             */
/*                     nor WIN32 is set.                                   */
/*                                                                         */
/*       __cplusplus   define for C++ applications (normally defined       */
/*                     automatically by the compiler)                      */
/*                                                                         */
/***************************************************************************/

/*
 * $Id: can_def.h,v 1.2 2003/10/31 15:16:38 kno Exp $
 */

#ifndef  _CAN_DEF_H
#define  _CAN_DEF_H

#include "BaseTypes.h"



/* remove comment lines for building a WIN3.11 application                 */
/*  #define WIN16 */
/* remove comment lines for building a WIN-NT4.0 or WIN95 application      */
/*  #define WIN32 */
/* remove comment lines for building a MS-DOS application                  */
/* #define DOS    */

/* compatibility with borland */
#ifdef __WIN32__
#ifndef WIN32
#define  WIN32
#endif
#endif

/* compatibility with borland */
#if defined (__MSDOS__) || defined (_DOS)
#ifndef DOS
#define DOS
#endif
#endif

#ifdef __linux__
#define LINUX
#endif

#ifndef LINUX
#if !(defined (WIN16) || defined (WIN32))
/* default setting is DOS */
#ifndef DOS
#define DOS
#endif
#endif
#endif

/* check macro definitions */
#ifdef DOS
#if defined(WIN16) || defined (WIN32)
#error only one macro definition (DOS or WIN16 or WIN32) allowed
#endif
#endif

#ifdef WIN16
#if defined(DOS) || defined (WIN32)
#error only one macro definition (DOS or WIN16 or WIN32) allowed
#endif
#endif

#ifdef WIN32
#if defined(WIN16) || defined (DOS)
#error only one macro definition (DOS or WIN16 or WIN32) allowed
#endif
#endif

/* set the switch DOS, if a MS-DOS application is build  */
#ifdef  DOS

#ifdef F_M                      /* far memory model */
#ifndef FAR
#define FAR far
#endif
#else /* F_M */
#ifndef FAR
#define FAR
#endif
#endif /* F_M */

#ifdef __cplusplus
#ifndef PRAEDEF
#define PRAEDEF extern "C"
#endif
#ifndef PRAEDECL
#define PRAEDECL  extern "C"
#endif
#else /* cplusplus */
#ifndef PRAEDEF
#define PRAEDEF
#endif
#ifndef PRAEDECL
#define PRAEDECL
#endif
#endif


#ifndef PRAEDECL
#define PRAEDECL
#endif

#ifndef MIDDECL
#define MIDDECL
#endif

#ifndef MIDDEF
#define MIDDEF
#endif



#define FALSE           0
#define TRUE            1
#define UNIT USIGN32
#ifndef NULL
#define NULL            0
#endif

#endif /* _DOS */

/* set the switch WIN32, if a Windows 95 or a Windows NT application is build  */


#define PRAEDEF
#define PRAEDECL


#define MIDDECL
#define MIDDEF

#ifndef FAR
#define FAR
#endif

#ifndef PASCAL
#define PASCAL
#endif


#ifndef _export
#define _export
#endif

#ifndef far
#define far
#endif

#ifndef _far
#define _far
#endif

/* linux defines */
#ifdef LINUX

#define FALSE           0
#define TRUE            1
#define BYTE USIGN8
#define WORD USIGN32
#define DWORD USIGN32
#define UNIT USIGN32
#ifndef NULL
#define NULL            0
#endif



#endif


#endif /* _CAN_DEF_H */
