/*
 * Can-Driver for Softing Can-Card
 * Copyright (C) 1994-2003, Softing AG, Gunnar Larisch, Werner Knorsch
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * email: support.automation@softing.com
 * Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany
 */

/*
 * $Id: can_loadcard.h,v 1.2 2003/10/31 15:16:38 kno Exp $
 */

#ifndef _LOADCARD_H_
#define _LOADCARD_H_

typedef struct device_load_data_s
{
    USIGN32 uiDPRAMSize;
    USIGN32 uiOffsetBootFile;
    USIGN32 ulAddrBootFile;
    USIGN32 uiOffsetLoadFile;
    USIGN32 ulAddrLoadFile;
    USIGN32 uiOffsetDNLData;
    USIGN32 uiMaxDataRecordSize;
    USIGN32 ulAbsAddrDPRAMFromCardView;
}
DEVICE_LOAD_DATA;
typedef DEVICE_LOAD_DATA *PDEVICE_LOAD_DATA;

/* Prototypen */
extern int LoadCard(SCHAR *, SCHAR *, VOID (*)(SCHAR *), PVOID pDevice);
extern int EnableCard(SCHAR *, VOID (*)(SCHAR *));
extern int SwitchOffCard(SCHAR *, VOID (*)(SCHAR *));
//extern int ResetCard(SCHAR *, VOID (*)(SCHAR *));
extern int TestCardPresent(SCHAR *, VOID (*)(SCHAR *));

extern USIGN8 FAR *GetDPRAMPtr(VOID);
extern USIGN8 FAR *GetAttributeMemoryPtr(VOID);
extern VOID SetVpp(int VPP1, int VPP2);


int ReadInitialization(SCHAR *, VOID (*)(SCHAR *));
USIGN32 FAR GetINI_IRQ_Nr(VOID);
VOID FAR SetINI_IRQ_Nr(USIGN32);
USIGN32 FAR GetINI_Socket_Nr(VOID);


//VOID SetINIData(CANPC_RESOURCES CanCardRessource);

#endif /* _LOADCARD_H */
