/*
 * Can-Driver for Softing Can-Card
 * Copyright (C) 1994-2003, Softing AG, Gunnar Larisch
 * 
 * See file CREDITS for list of people who contributed to this
 * project.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * email: support.automation@softing.com
 * Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany
 */

/*
 * $Id: can_pcmcia.h,v 1.3 2003/10/31 15:16:38 kno Exp $
 */


#ifndef __CANCARD_H__
#define __CANCARD_H__

/******************************************************************
**  macros
*******************************************************************/

#define CAN_DPRAM_SIZE         0x1000   /* DPRAM size */
#define CANATTRIBUTEMEMSIZE    0x1000     // size of attribute memory #
#define PNP_PCMCIA_VENDOR_ID   0x0168L // PCMCIA Vendor ID Softing
#define DRIVERNAME             "cancard_cs"        // Driver name


/******************************************************************
** protoypes  
*******************************************************************/

int can_init(VOID);
VOID can_cleanup(VOID);
int can_init(VOID);
VOID can_cleanup(VOID);

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
irqreturn_t CancardInterrupt(int irq, void *dev_id, struct pt_regs *regs);
#else
    irqreturn_t CancardInterrupt(int irq, void *dev_id);    
#endif

/*
   The attach() and detach() entry points are used to create and destroy
   "instances" of the driver, where each instance represents everything
   needed to manage one actual PCMCIA card.
*/


#if LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,12) 
#define WITH_CARDSERVICES
dev_link_t *CANcard_attach(VOID);
VOID CANcard_detach(dev_link_t *);
#warning this driver is developed for kernel version 2.6.13-2.6.17 and tested with kernel version 2.6.13, 2.6.16 and 2.6.17
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,13) 
#if LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,15) 
dev_link_t *CANcard_attach(VOID);
VOID CANcard_detach(dev_link_t *);
#define WITH_OLD_ATTACHE
//#warning version less 2.6.16
#endif
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16) 
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,17) 
dev_link_t *CANcard_attach(VOID);
VOID CANcard_detach(dev_link_t *);
#define WITH_PROBE
//#warning version greater 2.6.15
#endif
#endif


#endif // __CANCARD_H__
