/*
    can_proc.h
    handles the proc file access for the CAN-PCI devices.
    Copyright (C) 2015  kno@softing.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

extern struct proc_dir_entry *procDir, *procFile;

#if LINUX_VERSION_CODE < KERNEL_VERSION(3,10,0)
int ReadProc(char *buf, char **start, off_t offset, int size, int *eof, void *data);
#else
ssize_t ReadProc(struct file *filp, char *buf, size_t count, loff_t *offset);
#endif

loff_t SeekProc(struct file *filp, loff_t off, int whence);

struct proc_dir_entry *create_proc_file(USIGN8 * name, struct proc_dir_entry *parent, void *data);
