/*
 * Can-Driver for Softing Can-Card
 * Copyright (C) 1994-2003, Softing AG, Gunnar Larisch, Werner Knorsch
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * email: support.automation@softing.com
 * Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany
 */

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* PROJECT_NAME           CAN LAYER2                                            */
/* MODULE                 OS.H                                        */
/* COMPONENT_LIBRARY                                                        */
/* AUTHOR                 W.Knorsch                                      */
/* VERSION                1.0                                               */
/* DATE                   16.06.07                                          */
/*                                                                          */
/* MODULE_DESCRIPTION     header file for os specific includes                */
/*                                                                          */
/*HEAD_END*******************************************************************/

/*
 *
 */
/******************************************************************
**  include files
*******************************************************************/

#ifndef _OS_H_
#define _OS_H_

#include <linux/version.h>
#include <linux/mm.h>

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19)
#include <linux/config.h> 
#else
#if LINUX_VERSION_CODE < KERNEL_VERSION(3,0,0)
#include <linux/autoconf.h>
#endif    
#endif


#include <linux/module.h>
#include <linux/signal.h>
#include <linux/kernel.h>       /* printk() */
#include <linux/init.h>
#include <linux/ptrace.h>
#include <linux/slab.h>
#include <linux/string.h>
#include <linux/timer.h>
#include <linux/time.h>
#include <linux/ioport.h>
#include <asm/io.h>
#if LINUX_VERSION_CODE < KERNEL_VERSION(3,4,0)
#include <asm/system.h>
#endif

#include <linux/fs.h>           /* everything... */
#include <linux/errno.h>        /* error codes */
#include <linux/delay.h>        /* udelay */

#include <linux/mman.h>
#include <linux/interrupt.h>


// PCMCIA
#ifdef CANCARD
//#include <pcmcia/version.h>
#include <pcmcia/cs_types.h>
#include <pcmcia/cs.h>
#include <pcmcia/cistpl.h>
#include <pcmcia/cisreg.h>
#include <pcmcia/ds.h>
#include "BaseTypes.h"

// Test la
//#include <pcmcia/bulkmem.h>
#include <pcmcia/cs_types.h>
#include <pcmcia/ss.h>
#endif // CANCARD




#endif
