/*****************************************************************************/
/*                                                                           */
/*   Softing AG           Richard-Reitzner-Allee 6       85540 Haar          */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*      Copyright (C) by Softing AG, 1999-2007   All rights reserved.        */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*                               pc8.h                                    */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/* PROJECT:                  Softing CAN Layer2                              */
/*                                                                           */
/* SWKE:                    <SWKE_identifier>                                */
/*                                                                           */
/* COMPONENT:                CAN-ECOx specific part                          */
/*                                                                           */
/* AUTHOR:                     Softing AG                                    */
/*                                                                           */
/* GENERATION_DATE:            21.05.07                                      */
/*                                                                           */
/* FUNCTIONAL_DESCRIPTION:    CAN-ECOx specific part                         */
/*                                                                           */
/*****************************************************************************/

#define CAN_DPRAM_SIZE 0x1000   /* DPRAM size */
#define DRIVERNAME     "fanucpc8"  // Driver name

#define WR_BYTE(a,v) outb(v,(CAN_ADDRESS)a)
#define RD_BYTE(a) inb((CAN_ADDRESS)a)
#define RD_USIGN32(a) inl((CAN_ADDRESS)a)


INT32 pc8_enable_fifo(PCDEVICES pDevice);
INT32 pc8_enable_fifo_transmit_ack(PCDEVICES pDevice);
INT32 pc8_enable_error_frame_detection(PCDEVICES pDevice);
INT32 pc8_start_chip(PCDEVICES pDevice);
INT32 pc8_get_time(PCDEVICES pDevice, PUSIGN32 time);
INT32 pc8_reset_rcv_fifo(RCV_FIFO_PC8_STRUCT *pRcvFifo);
INT32 pc8_reset_xmt_fifo(XMT_FIFO_PC8_STRUCT *pXmtFifo);
INT32 pc8_read_rcv_fifo_level(RCV_FIFO_PC8_STRUCT *pRcvFifo);
INT32 pc8_read_xmt_fifo_level(XMT_FIFO_PC8_STRUCT *pXmtFifo);
INT32 pc8_send_remote (PCDEVICES pDevice, USIGN32 Ident, INT32 Xtd, INT32 DataLength);
INT32 pc8_enable_dyn_obj_buf(PCDEVICES pDevice);
INT32 pc8_read_ac(PCDEVICES pDevice, PARAM_STRUCT *param);

INT32 pc8_define_object (PCDEVICES pDevice,
                          USIGN32 Ident,
                          PINT32 ObjectNumber,
                          INT32 Type,
                          INT32 ReceiveIntEnable,
                          INT32 AutoRemoteEnable,
                          INT32 TransmitAckEnable);

INT32 pc8_define_cyclic (PCDEVICES pDevice,
                          INT32          ObjectNumber,
                          unsigned int Rate,
                          unsigned int Cycles);

INT32 pc8_initialize_interface(PCDEVICES pDevice,
                                INT32 ReceiveFifoEnable,
                                INT32 ReceivePollAll,
                                INT32 ReceiveEnableAll,
                                INT32 ReceiveIntEnableAll,
                                INT32 AutoRemoteEnableAll,
                                INT32 TransmitReqFifoEnable,
                                INT32 TransmitPollAll,
                                INT32 TransmitAckEnableAll,
                                INT32 TransmitAckFifoEnableAll,
                                INT32 TransmitRmtFifoEnableAll);


INT32 pc8_send_remote_object(PCDEVICES pDevice, INT32 Ident, INT32 DataLength);
INT32 pc8_supply_object_data(PCDEVICES pDevice, INT32 Ident, INT32 DataLength, PUSIGN8 pData);
INT32 pc8_supply_rcv_object_data(PCDEVICES pDevice, INT32 Ident, INT32 DataLength, PUSIGN8 pData);
INT32 pc8_write_object(PCDEVICES pDevice, INT32 Ident, INT32 DataLength, PUSIGN8 pData);
INT32 pc8_read_rcv_data(PCDEVICES pDevice, INT32 Ident, PUSIGN8 pData, PUSIGN32 Time);
INT32 pc8_read_xmt_data(PCDEVICES pDevice, INT32 Ident, PINT32 pDataLength, PUSIGN8 pXMTData);
INT32 pc8_init_signals (PCDEVICES pDevice, USIGN32 ulChannelDirectionMask, USIGN32 ulChannelOutputDefaults);

/*
INT32 pc8_set_green_led_feature(PCDEVICES pDevice, LED_FEATURE *pFeature);
INT32 pc8_set_red_led_feature(PCDEVICES pDevice, LED_FEATURE *pFeature);
*/




USIGN32 pc8drv_get_time(FANUCPC8 *pPc8);



void reset_xmt_fifo(XMT_FIFO_PC8_STRUCT *pXmtFifo);
void reset_rcv_fifo(RCV_FIFO_PC8_STRUCT *pRcvFifo);




INT32 pc8_send_data (PCDEVICES pDevice, 
                      USIGN32 Ident,
                      INT32 Xtd,
                      INT32 DataLength,
                      PUSIGN8 pData);


INT32 pc8_reset_chip(PCDEVICES pDevice);

INT32 pc8_initialize_chip (PCDEVICES pDevice,
                            INT32 presc,
                            INT32 sjw,
                            INT32 tseg1,
                            INT32 tseg2,
                            INT32 sam);

INT32 pc8_set_acceptance(PCDEVICES pDevice, 
                          unsigned int AccCodeStd,
                          unsigned int AccMaskStd,
                          USIGN32 AccCodeXtd,
                          USIGN32 AccMaskXtd);

INT32 pc8_set_output_control(PCDEVICES pDevice, INT32 OutputControl);



INT32 pc8_read_object_dyn(PARAM_STRUCT *param, 
           volatile RCV_OBJECT *pRcvObject, 
           volatile RCV_DYN_STRUCT *pDynRcvStruct, 
           USIGN32 Ident);

INT32 pc8_read_ac_dyn(PCDEVICES pDevice, PARAM_STRUCT *param);
INT32 pc8_read_ac_stat(PCDEVICES pDevice, PARAM_STRUCT *param);
INT32 pc8_read_rcv_data_stat(PCDEVICES pDevice, INT32 Ident, PUSIGN8 pData, PUSIGN32 Time);
INT32 pc8_read_rcv_data_dyn(PCDEVICES pDevice, INT32 Ident, PUSIGN8 pData, PUSIGN32 Time);
INT32 pc8_send_remote_object_stat(PCDEVICES pDevice, INT32 Ident, INT32 DataLength);
INT32 pc8_send_remote_object_dyn(PCDEVICES pDevice, INT32 Ident, INT32 DataLength);
INT32 pc8_supply_object_data_dyn(PCDEVICES pDevice, INT32 Ident, INT32 DataLength, PUSIGN8 pData);
INT32 pc8_supply_object_data_stat(PCDEVICES pDevice, INT32 Ident, INT32 DataLength, PUSIGN8 pData);
INT32 pc8_supply_rcv_object_data_stat(PCDEVICES pDevice, INT32 Ident, INT32 DataLength, PUSIGN8 pData);
INT32 pc8_supply_rcv_object_data_dyn(PCDEVICES pDevice, INT32 Ident, INT32 DataLength, PUSIGN8 pData);
INT32 pc8_send_object(PCDEVICES pDevice, INT32 Ident, INT32 DataLength);
INT32 pc8_send_object_stat(PCDEVICES pDevice, INT32 Ident, INT32 DataLength);
INT32 pc8_write_object_dyn(PCDEVICES pDevice, INT32 Ident, INT32 DataLength, PUSIGN8 pData);
INT32 pc8_write_object_stat(PCDEVICES pDevice, INT32 Ident, INT32 DataLength, PUSIGN8 pData);
INT32 pc8_read_xmt_data_stat(PCDEVICES pDevice, INT32 Ident, PINT32 pDataLength, PUSIGN8 pXMTData);
INT32 pc8_read_xmt_data_dyn(PCDEVICES pDevice, INT32 Ident, PINT32 pDataLength, PUSIGN8 pXMTData);











