/*
 * Can-Driver for Softing Can-Card
 * Copyright (C) 1994-2003, Softing AG, Gunnar Larisch
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 *
 * email: support.automation@softing.com
 * Softing AG, Richard-Reitzner-Allee 6, 85540 Haar, Germany
 */

/***************************************************************************/
/*                                                                         */
/*                     sbn_buf.h                                           */
/*                                                                         */
/***************************************************************************/
/*                                                                         */
/* PROJECT:            CANCARD FIRMWARE                                    */
/*                                                                         */
/* AUTHOR:             Lennart Seck                                        */
/*                                                                         */
/* Funktion  : Stellt die Routinen zum Lesen                               */
/*             von SBN-Records aus einem Puffer zur                        */
/*             Verfuegung.                                                 */
/*                                                                         */
/***************************************************************************/

/*
 * $Id: sbn_buf.h,v 1.2 2003/10/31 15:16:38 kno Exp $
 */

#include "BaseTypes.h"

#define _TypeSBINString_    0xffff
#define _TypeSBINData_      0x0000
#define _TypeSBINEndOfFile_ 0x0001
#define _TypeSBINStart_     0x0003


int ReadSBINRecordFromBuffer(USIGN8 *pSBNBufferDat,
                             USIGN32 *pSBNBufferIndex,
                             int CalcChecksum, USIGN32 MaxDataLen,
                             USIGN32 *Type, USIGN8 *Data,
                             USIGN32 *Addr, USIGN32 *Len,
                             USIGN32 *DataCheckSum);
