
/***************************************************************************
 *   mk_devices.c - generates the device files for the Softing CAN devices *
 *   Copyright (C) 2003-2015 by Softing Industrial Automation GmbH                    *
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


char *getDeviceName(unsigned int deviceType)
{
  static char canac104[]="CAN-AC PC104";
  static char caneco104[]="CAN-ECOx-104";
  static char canpro104plus[]="CANpro 104+";
  static char canpropcie[]="CANpro PCIe";
  static char canacpci[]="CAN-AC PCI";
  static char cancard2[]="CANcard2";
  static char ediccard2[]="EDICcard2";
  static char canprousb[]="CANpro USB";
  static char onboardcan[]="On_Board_CAN";
  static char unknown[]="UNKNOWN";
  
  char *pName;
  
    switch(deviceType)
  {
    case 5:
      pName = cancard2;
      break;
    
    case 7:
    case 8:
      pName = canacpci;
      break;
    
    case 9:
      pName = canac104;
      break;
      
    case 12:
      pName = caneco104;
      break;
    
    case 13:
      pName = canpropcie;
      break;
    
    case 14:
      pName = canpro104plus;
      break;
    
    case 15:
      pName = canprousb;
      break;
    
    case 0x105:
      pName = ediccard2;
      break;
    
    case 0x8000:
      pName = onboardcan;
      break;
    
    default:
      pName = unknown;
      break;
    
  }
  
  return pName;

}