/***************************************************************************
 *   Copyright (C) 2007-2015 by Softing Industrial Automation GmbH         *
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _CAN_BASETYPE_H_
#define _CAN_BASETYPE_H_

#include <linux/types.h>
#include "CanKeywords.h"

#ifdef WIN32
#include <Windows.h>
#endif /* WIN32 */

#ifndef NULL
#ifdef __cplusplus
#define NULL 0
#else /* __cplusplus */
#define NULL ((void *) 0)
#endif
#endif /* NULL */


/* -------- TRUE and FALSE definition -------------------------------------- */

#define     CAN_TRUE             (BYTE)0xFF

#define     CAN_FALSE            (BYTE)0x00


// * ------- global data type definitions ------------------------------------ */
// *** datatype :                                            VOID            ***/
#ifndef VOID
#define VOID                     void
#endif // * VOID */

#ifndef PVOID
#define PVOID                    void*
#endif // * PVOID */



typedef unsigned long CAN_ADDRESS;


//   *** datatype :                                            CAN_BOOL  b     ***/
typedef __u8 CAN_BOOL, *PCAN_BOOL;

// *** datatype :  BOOL  b     ***/
// #ifdef BOOL
typedef __s8 BOOL, *PBOOL;
// #endif 

// *** datatype :                                            USIGN8    u8    ***/
typedef __u8 USIGN8, *PUSIGN8;

// *** datatype :                                            USIGN16   u16   ***/
typedef __u16 USIGN16, *PUSIGN16;

// *** datatype :                                            USIGN32   u32   ***/
typedef __u32 USIGN32, *PUSIGN32;

// *** datatype :                                            USIGN64   u64   ***/
typedef __u64 USIGN64, *PUSIGN64;

//*** datatype :                                            INT8      i8    ***/
typedef __s8 INT8, *PINT8;

//*** datatype :                                            INT16     i16   ***/
typedef __s16 INT16, *PINT16;

//*** datatype :                                            BYTE      by    ***/
typedef __u8 BYTE, *PBYTE;

//*** datatype :                                            OCTET     o     ***/
typedef __u8 OCTET, *POCTET;

//*** datatype :                                            WORD      w     ***/
typedef __u16 WORD, *PWORD;

//*** datatype :                                            DWORD     dw    ***/
typedef __u32 DWORD, *PDWORD;

//*typedef unsigned int UINT; */

//*** datatype :                                            INT32     i32   ***/
#ifndef WIN32
//* in WIN32 INT32 is already defined as int (basetsd.h) */
typedef __s32 INT32, *PINT32;
#endif //* !WIN32 */

//*** datatype :                                            FLOAT     f     ***/
typedef float FLOAT, *PFLOAT;

//*** datatype :                                            DOUBLE    d     ***/
typedef double DOUBLE, *PDOUBLE;

//*** datatype :                                            TCHAR     c     ***/
#ifndef WIN32
typedef __s8 SCHAR, *PSCHAR;
#endif //*WIN32 */


#ifndef BOOLEAN
#define BOOLEAN int
#endif

#define ULONG unsigned long
#define TCHAR unsigned char
#define LPBYTE unsigned char *
#define CAN_HANDLE unsigned long
#define LPVOID void *

#endif //*_CAN_BASETYPE_H_ */
