/***************************************************************************
 *   Copyright (C) 2007-2015 by Softing Industrial Automation GmbH         *
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef CH_CFG_ALL_H
#define CH_CFG_ALL_H

#include <klineedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qfile.h>
#include <qstring.h>


#include "ui_ch_config_pro.h"
#include "ui_ch_config.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <linux/kdev_t.h>
#include <dirent.h>
#include <errno.h>
#include "channel.h"


class ch_cfg_all: public QObject
{
  Q_OBJECT
public:
    ch_cfg_all(CHANNEL *pChannel = NULL);
    virtual ~ch_cfg_all();
    USIGN32 m_tseg1;
    USIGN32 m_tseg2;
    USIGN32 m_prescaler;
    USIGN32 m_sam;
    USIGN32 m_sjw;
    USIGN32 m_u32AccCodeStd;
    USIGN32 m_u32AccMaskStd;
    USIGN32 m_u32AccCodeXtd;
    USIGN32 m_u32AccMaskXtd;
    USIGN32 m_u32OutputCtrl;
    double  m_fBaudrate;
    QString m_CTableText;
    QString m_channelName;
    bool    m_ok;
    void    show_config(void);
    bool    is_ack_enabled(void);
    void    set_ack_enabled(bool yesno);
    bool    is_errorframe_detection_enabled(void);
    void    set_error_frame_detection_enabled(bool yesno);
    
    
public slots:
  virtual void on_tseg1();
    virtual void on_tseg2();
    virtual void on_baudrate();
    virtual void on_presc();
    virtual void on_sjw();
    virtual void on_sam();
    virtual void on_acc_mask();
    virtual void on_acc_code();
    virtual void on_output_ctrl();
    virtual void on_acc_xtd_code();
    virtual void on_acc_xtd_mask();
    virtual void on_cellClicked(int, int);
    virtual void on_ok();
    virtual void on_cancel();
    virtual void on_channel_name();
  
  private:
    CAN_CONTROLER_INIT m_aModiTable[MAX_MODUS];
    
    virtual void ShowAll(USIGN32 Tseg1AndTseg2Int);
    virtual void update_all();
    virtual bool read_all();
    virtual void PrintTable(USIGN32 u32MaxEntry);
    virtual int getNumOfCol(void);
    virtual void deleteAllTabEntries(void);
    Ui::ch_configpro m_pro;
    Ui::ch_config m_ac;
    
    QDialog m_w;
  
 
};

#endif // CH_CFG_ALL_H
