/***************************************************************************
 *   Copyright (C) 2007-2015 by Softing Industrial Automation GmbH         *
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CLSS_H
#define CLSS_H

#include "ui_lss.h"
#include <qtextedit.h>
#include <qlineedit.h>

#include "BaseTypes.h"
#include "can_def.h"
#include "canL2.h"
#include "cmadef.h"
#include "cmaret.h"


class lss: public QDialog //d_lss
{
    Q_OBJECT
public:
    lss(CAN_HANDLE can=0, QWidget *parent = 0);
    ~lss(void);
    CAN_HANDLE m_Can;
    QDialog* m_pw;

signals:
    void doPrint(QString toPrint);


public slots:
    virtual void OnSwModeSel();
    virtual void OnSwModeGlobal();
    virtual void OnStore();
    virtual void OnInqRevNr();
    virtual void OnInqSerial();
    virtual void OnInqProdCode();
    virtual void OnInqNodeId();
    virtual void OnLssInit();
    virtual void OnIdentifyRemSlaves();
    virtual void OnIdentifyNonCfgSlaves();
    virtual void OnCfgNodeid();
    virtual void OnCfgBaud();
    virtual void OnActivateBaud();
    virtual void OnInquireVendor();

private:
    Ui::d_lss m_ui;
};

#endif
