/***************************************************************************
 *   Copyright (C) 2007-2015 by Softing Industrial Automation GmbH         *
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef COTHREAD_H
#define COTHREAD_H

/**
	@author Werner Knorsch <kno@softing.com>
*/
#include <kapplication.h>
#include <qthread.h>
#include <qtextedit.h>
#include <qmutex.h>
#include "BaseTypes.h"
#include "can_def.h"
#include "canL2.h"
#include "cmadef.h"
#include "cmaret.h"
#include "cnmt.h"

extern KApplication *pApp;

class CoThread: public QThread
{
    Q_OBJECT
public:

    CoThread(USIGN8 Can);
    int HandleEvent(CMA_EventStruct *pEvent);
    QString& getErrorText(USIGN32 errorCode);
    QString& getStateText(USIGN8 state);
    QString& getEMCYText(USIGN16 code);


    virtual void run();

    CO_NODE   *m_pNodes;
    CAN_HANDLE m_Can;

signals:
    void sigPdoRcv(unsigned long pdohndl, unsigned char len, quint64 data);
    void sigSdoRcv(unsigned long len, quint64 data);
    void doPrint(QString toPrint);
    void sig_errorEvent(unsigned char nodeId, unsigned char eventType, int state);

private:
    USIGN16 getBufferVal16(void* buffer);
    USIGN32 getBufferVal32(void* buffer);

};


#endif
