/***************************************************************************
 *   Copyright (C) 2007-2015 by Softing Industrial Automation GmbH         *
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CPDO_H
#define CPDO_H

#include <qtextedit.h>
#include <qcheckbox.h>
#include <qlineedit.h>

#include "ui_pdo.h"
#include "BaseTypes.h"
#include "can_def.h"
#include "canL2.h"
#include "cmadef.h"
#include "cmaret.h"
#include "cinstall.h"
#include "cremove.h"
#include "cread.h"
#include "cwrite.h"


class pdo: public QDialog //cpdo
{
    Q_OBJECT
public:
    pdo(CAN_HANDLE can=0, QWidget *parent = 0);
    ~pdo(void);
    CAN_HANDLE m_Can;
    INT32    m_SelectedRow;
    QDialog* m_pw;
    void Print(QString& msg);

signals:
    void doPrint(QString toPrint);


public slots:
    virtual void OnWritePdo();
    virtual void OnReadPdo();
    virtual void OnRemovePdo();
    virtual void OnInstallPdo();
    virtual void OnOk();
    virtual void OnPdoReceived(unsigned long pdohndl, unsigned char len, quint64 data);
    virtual void OnTableRowClicked(int x, int y);
    virtual void OnInstallPdoFinished(int ret);
    virtual void OnRemovePdoFinished(int ret);
    virtual void OnReadPdoFinished(int ret);
    virtual void OnWritePdoFinished(int ret);


private:
    QString& formatPdoData(USIGN8 *pData, USIGN8 len, QString& ret);
    int findTableRow(USIGN32 cobid);
    Ui::d_pdo m_ui;
    cremove *m_removePdo;
    cinstall *m_installPdo;
    cwrite *m_writePdo;
    cread *m_readPdo;

};

#endif
