/***************************************************************************
 *   Copyright (C) 2007-2015 by Softing Automation GmbH                    *
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#include "cread.h"

cread::cread(CAN_HANDLE can, QWidget *parent)
    :QDialog(parent)
{
    m_pw = new QDialog(this);
    m_ui.setupUi(m_pw);

    m_pw->show();
    connect(m_ui.bt_ok, SIGNAL(clicked()), this, SLOT(accept()));  
    connect(m_ui.bt_cancel, SIGNAL(clicked()), this, SLOT(reject()));  
    connect(m_ui.bt_read, SIGNAL(clicked()), this, SLOT(OnRead()));  
    
    m_Can = can;

}

cread::~cread()
{
  delete m_pw;
}

void cread::OnRead()
{
    USIGN16 retCode;
    bool isValid;
    USIGN8 data[8];
    QString data_text;
    int i;
    
    for(i=0; i<8; i++)
    {
      data[i]=0;
    }

    if((retCode = CMA_ReadPDO(m_Can, m_ui.ed_pdo_handle->text().toShort(&isValid,16), data)))
    {
        return;
    }
      
    data_text = data_text.sprintf("0x%02x", data[0]);
    m_ui.ed_bt0->setText(data_text);
    data_text = data_text.sprintf("0x%02x", data[1]);
    m_ui.ed_bt1->setText(data_text);
    data_text = data_text.sprintf("0x%02x", data[2]);
    m_ui.ed_bt2->setText(data_text);
    data_text = data_text.sprintf("0x%02x", data[3]);
    m_ui.ed_bt3->setText(data_text);
    data_text = data_text.sprintf("0x%02x", data[4]);
    m_ui.ed_bt4->setText(data_text);
    data_text = data_text.sprintf("0x%02x", data[5]);
    m_ui.ed_bt5->setText(data_text);
    data_text = data_text.sprintf("0x%02x", data[6]);
    m_ui.ed_bt6->setText(data_text);
    data_text = data_text.sprintf("0x%02x", data[7]);
    m_ui.ed_bt7->setText(data_text);
    
}
