/***************************************************************************
 *   Copyright (C) 2007-2015 by Softing Industrial Automation GmbH         *
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef CSDO_H
#define CSDO_H

#include "ui_sdo.h"
#include <qtextedit.h>
#include <qlineedit.h>
#include <qradiobutton.h>

#include "BaseTypes.h"
#include "can_def.h"
#include "canL2.h"
#include "cmadef.h"
#include "cmaret.h"


class sdo: public QDialog //d_sdo
{
    Q_OBJECT

public:
    sdo(CAN_HANDLE can=0, QWidget *parent = 0);
    ~sdo(void);
    CAN_HANDLE m_Can;
    QDialog* m_pw;

signals:
    void doPrint(QString toPrint);

public slots:
    virtual void OnDouble();
    virtual void OnLong();
    virtual void OnWord();
    virtual void OnByte();
    virtual void OnUpload();
    virtual void OnDownload();
    virtual void OnBlockUpload();
    virtual void OnBlockDownload();
    virtual void OnOk();
    virtual void OnSdoUploadComplete(unsigned long len, quint64 data);


private:
    USIGN8 m_type;
    Ui::d_sdo m_ui;

};

#endif
