/***************************************************************************
 *   Copyright (C) 2007-2015 by Softing Industrial Automation GmbH         *
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MASTER_H
#define MASTER_H


#include <KDE/KMainWindow>

#include "ui_master.h"

#include "cothread.h"

#include "qtextedit.h"
#include "qlineedit.h"
#include "qstring.h"
#include "qpushbutton.h"

#include "BaseTypes.h"
#include "can_def.h"
#include "canL2.h"
#include "cmadef.h"
#include "cmaret.h"
#include "cnmt.h"
#include "cpdo.h"
#include "csdo.h"
#include "clss.h"



/**
 * This class serves as the main window for master.  It handles the
 * menus, toolbars and status bars.
 *
 * @short Main window class
 * @author Your Name <mail@example.com>
 * @version 0.1
 */
class master : public KMainWindow
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    master();

    /**
     * Default Destructor
     */
    virtual ~master();

    CoThread *m_thread;
    nmt *m_pnmt;
    pdo *m_ppdo;
    sdo *m_psdo;
    lss *m_plss;

public slots:
    virtual void OnStartup();
    virtual void OnPdo();
    virtual void OnNmt();
    virtual void OnSdo();
    virtual void OnLss();
    virtual void OnSdoFinished(int ret);
    virtual void OnPdoFinished(int ret);
    virtual void OnLssFinished(int ret);
    virtual void OnNmtFinished(int ret);
    virtual void OnPrint(QString PrintIt);
    virtual void OnClear();

// signals:
//   void sig_print(QString toPrint);


private:
    // this is the name of the root widget inside our Ui file
    // you can rename it in designer and then change it here
    Ui::mainWidget m_ui;
    USIGN8 m_ucHandle;
    QMutex m_mutex;



};

#endif // _MASTER_H_
