/*HEAD_BEG*********************** ********************************************/
/*                                                                          */
/* PROJECT_NAME           PCMCIA                                            */
/* MODULE                 CARD_CAN.C                                        */
/* AUTHOR                 S.Gemperlein                                      */
/* COMPANY                SOFTING GmbH Mnchen                              */
/* VERSION                1.0                                               */
/* DATE                   08.08.94                                          */
/* STATUS                                                                   */
/* REVIEWER               Ge                                                */
/* FUNCTIONAL_MODULE_DESCRIPTION                                            */
/*                                                                          */
/* FUNCTIONS              CANPC_reset_board                                 */
/*                        CANPC_reset_chip                                  */
/*                        CANPC_initialize_chip                             */
/*                        CANPC_initialize_chip2                            */
/*                        CANPC_set_mode                                    */
/*                        CANPC_set_mode2                                   */
/*                        CANPC_set_output_control                          */
/*                        CANPC_set_output_control2                         */
/*                        CANPC_set_acceptance                              */
/*                        CANPC_set_acceptance2                             */
/*                        CANPC_echo_tx_req                                 */
/*                        CANPC_echo_tx_req2                                */
/*                        CANPC_enable_fifo_transmit_ack                    */
/*                        CANPC_enable_fifo_transmit_ack2                   */
/*                        CANPC_start_chip                                  */
/*                                                                          */
/*                        CANPC_read_ac                                     */
/*                        CANPC_send_data                                   */
/*                        CANPC_send_data2                                  */
/*                        CANPC_send_remote                                 */
/*                        CANPC_send_remote2                                */
/*                                                                          */
/*HEAD_END*******************************************************************/


/***************************************************************************
 *   support.automation@softing.com                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*
*  {$Header: /cvs/projekte/CAN/usermode/wrapper/card_can.c,v 1.10 2007/08/29 11:01:58 kno Exp $}
*
*  {$Log: card_can.c,v $
*  {Revision 1.10  2007/08/29 11:01:58  kno
*  {*** empty log message ***
*  {
*  {Revision 1.2  2006/09/19 09:15:41  kno
*  {*** empty log message ***
*  {
*  {Revision 1.1  2006/09/07 12:38:01  kno
*  {*** empty log message ***
*  {
*  {Revision 1.1  2006/09/06 13:17:28  kno
*  {api_test
*  {}
* 
*    Rev 1.26   04 Apr 2001 11:10:04   kno
* Bugfixes bei Errorframes u. fast Fifo
* 
*    Rev 1.25   Mar 31 2000 13:07:14   kno
* Reinitialze fr Lowspeed-Modul ist jetzt
* m�lich
* 
*    Rev 1.24   Oct 25 1999 15:53:32   kno
* Def. von Receive Objekten liefert jetzt
* Fehler -1 bei DTS Software
* 
*    Rev 1.23   Oct 08 1999 10:17:00   kno
* Kein Bypass mehr am CAN Input Comparator
* (Clock Divider Register Bit 6 ge�dert)
* Betroffene Funktionen: reset_chip, set_mode
* 
* 
*    Rev 1.22   Sep 02 1999 15:24:14   kno
* WinCE Sourcen eingearbeitet;
* noch nicht vollst�dig ausgetestet
* 
*    Rev 1.14   Apr 06 1999 14:17:06   kno
* Menuestruktur ge�dert
* Device Menu eingefgt
* Sicherheitsrelevante Bereiche ausgeklammert
* 
*    Rev 1.13   Feb 24 1999 18:18:06   lese
* CANPC_initialize_chip(2): prescaler Werte-
* bereich auf 64 (bei SJA-devices) erhoeht.
* 
*    Rev 1.12   Feb 12 1999 14:41:38   lese
* Bugfix:  =/== Fehler in Vergleich behoben
*
*    Rev 1.11   Feb 09 1999 16:54:12   lese
* output control register: defaults f. CANcard2/
* EDICcard2
* 
*    Rev 1.10   Feb 05 1999 12:17:42   lese
* Bugfix: CANPC_get_time: Type mismatch 
* signed/unsigned char (vergleich) in while-
* Bedingung entfernt.
* 
*    Rev 1.9   Feb 02 1999 09:12:44   lese
* CANcard2 fuer CANalyzer
* 
*    Rev 1.8   Jan 28 1999 15:29:50   lese
* CANPC_get_time bugfix: lesen der 
* Timerwerte ueber DPR jetzt konsistent
* 
*    Rev 1.7   Jan 25 1999 10:43:46   lese
* Signal-Funktionen Borland-C-tauglich
* 
*    Rev 1.6   Jan 21 1999 16:07:34   lese
* Erweiterung f. PC104, Signal Funktionen 
* PCI und CC2 ueberarbeitet (kann nicht 
* mit Borland C uebersetzt werden wg . Bit-Felder) 
* 
* 
*    Rev 1.5   22 Dec 1998 16:38:42   lese
* umgestellt auf neue timer
* 
*    Rev 1.4   25 Sep 1998 15:20:24   lese
* Aenderungen in der Funktion wait_for_handshake
* 
*    Rev 1.3   14 Aug 1998 13:49:08   lese
* DOS-modus: Timer-alternative (ohne ftime() Aufrufe implem. (noch nicht volle
* ndet), CAN-AC2-PCI Zusaetze impl. (Piggyback-Funktionen)
* 
*    Rev 1.2   15 May 1998 15:36:32   lese
* CANCARD(NEC) and CANCARD-SJA run now with this library. Bugfix in read_ac()
* (WIN32) param-struct, Bus-state adapted
* 
*    Rev 1.0   18 Dec 1997 16:47:32   lese
* Initial revision.
*/



#include <stdio.h>
#include <string.h>
#include <pthread.h>

#include "BaseTypes.h"


#include "can_def.h"


#include "canL2.h"


#define _T(a) a
#define int_ptr int*
#define uns_long_ptr unsigned long*
#define uns_char_ptr unsigned char*
#define MAX_CHANNELS 3
#define OK_ 0



/* TIMER_48 declaraint_ptrtion part - start --------------------------------------- */
typedef struct  {
                  USIGN32  Ident;
                  INT32            DataLength;
                  INT32            RecOverrun_flag;
                  INT32            RCV_fifo_lost_msg;
                  unsigned char  RCV_data[8];
                  INT32            AckOverrun_flag;
                  INT32            XMT_ack_fifo_lost_acks;
                  INT32            XMT_rmt_fifo_lost_remotes;
                  INT32            Bus_state;
                  INT32            Error_state;
                  INT32            Can;
                  USIGN32  Time;
} param_struct;

 typedef enum ChipTypeEnum
{ _82365SL_,
    _DB86082_
}
__attribute__ ((packed)) ChipType;

 typedef struct canpc_ressources_s
{
  unsigned short uSocket;
  unsigned short uInterrupt;
  unsigned long ulDPRMemBase;
  USIGN32 ulDPRMemSize;
  ChipType uChip;
  unsigned short uIOAdress;
  unsigned short uRegisterBase;


}
__attribute__ ((packed)) CANPC_RESOURCES;



typedef struct
{
  INT32 number_of_rcv_objects;
  INT32 number_of_xmt_objects;
  INT32 dyn_enable;
  INT32 object_buffer_enable;

  unsigned long hChannel;
  USIGN32 DeviceType;
  USIGN32 PhysicalCh;
  BOOL          bIsUsed;
  
} channel_struct;

unsigned long time_temp1;
unsigned long time_temp2;
unsigned long time_temp3;
unsigned long time_temp1A;
unsigned long time_temp3A;

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;


/* TIMER_48 declaration part - end ----------------------------------------- */
//bitmask_union pb;
/* flag for first call of init_signals() */
 unsigned char SignalsDefined = 0;
 /* Softing device type derived from function */
 /* CANPC_get_device_id                       */

 /* definition of pointers to structures in dpram */


 channel_struct channel[MAX_CHANNELS];

 CANL2_CH_STRUCT ch1, ch2;
 BOOLEAN bSingleChannel;



 /* -------  application globals  -------------------------------------------*/
 BOOL boLoadCardSuccessful; /* defined in card_ini.c, LeSe 11/97 */



 USIGN32 bus_state=0;
 USIGN32 bus_state2=0;
 unsigned char old_status_reg  = 0;
 unsigned char old_status_reg2 = 0;


 unsigned char temp;

// TCHAR sysPath[80] = _T(".\\LOADCARD.INI");


 INT32 CANL2_synch_communication(CAN_HANDLE can);
 INT32 CANPC_init_signals (USIGN32 ulChannelDirectionMask,USIGN32 ulChannelOutputDefaults);

 INT32 CANPC_write_signals (USIGN32 ulChannelWrite, USIGN32 ulCareMask);

 INT32 CANPC_read_signals (USIGN32 * pulChannelRead);




 /*HEAD_BEG*******************************************************************/
 /*                                                                          */
 /* FUNCTION                       CANPC_get_device_id                       */
 /* FUNCTIONAL_DESCRIPTION         read device ID of the opened device       */
 /* OUTPUTS                        OK_ if device is open                     */
 /* CHANGES                        -                                         */
 /*                                                                          */
 /*HEAD_END*******************************************************************/
/*
 INT32 CANPC_get_device_id(USIGN32 *pulDeviceId)
{
 return CANL2_get_device_id(ch1.ulChannelHandle, pulDeviceId);
}
*/

 INT32 CANPC_get_fd(CAN_HANDLE* pCan1, CAN_HANDLE *pCan2)
{
  *pCan1 = ch1.ulChannelHandle;
  *pCan2 = ch2.ulChannelHandle;
  
  return 0;
  
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_reset_board                       */
/* FUNCTIONAL_DESCRIPTION         reset and download of firmware            */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_:    download ok                       */
/*                                ERROR1: no response of firmware           */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_reset_board(void)
{
  INT32 iRetVal=0;
  
  
  
  SignalsDefined=FALSE; // Lowspeed-Modul ist nicht initialisiert
  
#ifdef TRACE32
  return 0;  // kein Firmwaredownload beim Debuggen mit TRACE32
#endif
  
 
  return iRetVal;

}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_synch_communication               */
/* FUNCTIONAL_DESCRIPTION         synchronization with firmware             */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_:    communication with firmware       */
/*                                        synchronized                      */
/*                                ERROR4: failed                            */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
/*
INT32 CANPC_synch_communication(void)
{
  
  INT32 ret = 0;
  
  ret = CANL2_synch_communication(ch1.ulChannelHandle);
  
  if (ret) return ret;
  
  if(bSingleChannel) { return 0;}
  ret = CANL2_synch_communication(ch2.ulChannelHandle);
  
  if (ret) return ret;
  
  return ret;
  
}
   
*/
   
   /*HEAD_BEG*******************************************************************/
   /*                                                                          */
   /* FUNCTION                       CANPC_set_path                            */
   /* FUNCTIONAL_DESCRIPTION         Sets path where reset_board finds         */
   /*                                LOADCARD.INI                              */
   /* INPUTS                         -                                         */
   /* OUTPUTS                        OK_                                       */
   /*                                ERROR1: no response from firmware         */
   /* CHANGES                        -                                         */
   /*                                                                          */
   /*HEAD_END*******************************************************************/
INT32 CANPC_set_path(char *path)
{

  return (OK_);
}
   
   

   
   
   
/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_reinitialize                      */
/* FUNCTIONAL_DESCRIPTION         reinitialization of firmware              */
/* OUTPUTS                        OK_                                       */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_reinitialize(void)
{
#ifdef WITH_LOWSPEED
  if(SignalsDefined) 
{   // Portpins fr Piggyback werden in Reset versetzt

  SignalsDefined=FALSE;  // notwendig fr Aufruf von CANPC_init_signals
  CANPC_init_signals((USIGN32)0xFFFFFFFF,(USIGN32)0xF0F);
  CANPC_write_signals((USIGN32)0xF0F,(USIGN32)0xF0F);
  SignalsDefined=FALSE;
}
#endif

  CANL2_reinitialize(ch1.ulChannelHandle);
  if(bSingleChannel) { return 0;}
  CANL2_reinitialize(ch2.ulChannelHandle);
  
  return (OK_);
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_reset_rcv_fifo                      */
/* FUNCTIONAL_DESCRIPTION         resets receive fifo                       */
/* OUTPUTS                        OK_                                       */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_reset_rcv_fifo(void)
{
  CANL2_reset_rcv_fifo(ch1.ulChannelHandle);
  if(bSingleChannel) { return 0;}
  CANL2_reset_rcv_fifo(ch2.ulChannelHandle);
  
  return (OK_);
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_get_version                         */
/* FUNCTIONAL_DESCRIPTION         reads versions                            */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR4    timeout of firmware             */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_get_version(PINT32 sw_version, PINT32 fw_version, PINT32 hw_version,
                      PINT32 license, PINT32 can_chip_type)
{
  INT32 ret;
  INT32 hwVer;
  // if ch1 and ch2 on different cards: get version returns the version information of the card
  // where the channel "Softing_1" is physically located.
  
  ret = CANL2_get_version(ch1.ulChannelHandle, sw_version, fw_version, &hwVer, license, can_chip_type);
  if(ret) return ret;
  
  *hw_version = ((hwVer<<8) & 0xFF00) || ((hwVer>>8) & 0x00FF);
  
  // ret = CANL2_get_version(ch1.ulChannelHandle, &swv, &fwv, &hwv, &lic, chT);
  
    
  
  can_chip_type[1] = (bSingleChannel) ? 0 : can_chip_type[0];
  
  
  return ret;
}




/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_get_serial_number                   */
/* FUNCTIONAL_DESCRIPTION         reads serial number                       */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR4    timeout of firmware             */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_get_serial_number(PUSIGN32 serial_number)
{
  // if ch1 and ch2 on different cards: CANPC_get_serial_number returns the serialnumber of the card
  // where the channel "Softing_1" is physically located.
  return CANL2_get_serial_number(ch1.ulChannelHandle, serial_number);
}








/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_reset_chip                        */
/* FUNCTIONAL_DESCRIPTION         sw reset of CAN controllers               */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR4    timeout of firmware             */
/* CHANGES                                                                  */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_reset_chip(void)
{
  INT32 ret;
  
  
  ret = CANL2_reset_chip(ch1.ulChannelHandle);
  if(ret) return ret;
  if(bSingleChannel) { return 0;}
  ret = CANL2_reset_chip(ch2.ulChannelHandle);
  
  return ret;
}




/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_initialize_chip,                    */
/*                                CANPC_initialize_chip2                    */
/* FUNCTIONAL_DESCRIPTION         defines bittiming                         */
/* INPUTS                         presc:                [1..64]             */
/*                                sjw:                  [1..4]              */
/*                                tseg1:                [1..16]             */
/*                                tseg2:                [1..8]              */
/*                                sam:               0: 1 Sample            */
/*                                                   1: 3 Sample            */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR1    inconsistent parameters         */
/*                                ERROR4    timeout of firmware             */
/* CHANGES                                                                  */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_initialize_chip (INT32 presc,
                           INT32 sjw,
                           INT32 tseg1,
                           INT32 tseg2,
                           INT32 sam)
{

  return CANL2_initialize_chip (ch1.ulChannelHandle, presc,sjw,tseg1,tseg2,sam);
}
INT32 CANPC_initialize_chip2(INT32 presc,
                           INT32 sjw,
                           INT32 tseg1,
                           INT32 tseg2,
                           INT32 sam)
{
    
  if(bSingleChannel) { return 0; }


  return CANL2_initialize_chip (ch2.ulChannelHandle, presc,sjw,tseg1,tseg2,sam);

}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_set_mode,CANPC_set_mode2        */
/* FUNCTIONAL_DESCRIPTION         defines syncronisation control            */
/* INPUTS                         SleepMode 0: disable                      */
/*                                          1: enable (wakeup INT32           */
/*                                                     enabled ! )          */
/*                                SpeedMode 0: resynchronisation            */
/*                                             only with the recessive to   */
/*                                             dominant edge (high speed)   */
/*                                          1: resyn. rec -> dominant       */
/*                                             and dominant -> rec          */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR4    timeout of firmware             */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_set_mode(INT32 SleepMode,
                   INT32 SpeedMode)
{
  return 0;
}
INT32 CANPC_set_mode2(INT32 SleepMode,
                    INT32 SpeedMode)
{
  return 0;
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_set_acceptance,                   */
/*                                CANPC_set_acceptance2                   */
/* FUNCTIONAL_DESCRIPTION         defines acceptance filter masks and codes */
/*                                for both standard and extended frames     */
/* INPUTS                         AccCodeStd: acceptance code for std frames*/
/*                                AccMaskStd: accpetance mask for std frames*/
/* INPUTS                         AccCodeXtd: acceptance code for xtd frames*/
/*                                AccMaskXtd: accpetance mask for xtd frames*/
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_set_acceptance(USIGN32 AccCodeStd,
                         USIGN32 AccMaskStd,
                         USIGN32 AccCodeXtd,
                         USIGN32 AccMaskXtd)
{
  return CANL2_set_acceptance(ch1.ulChannelHandle, AccCodeStd, AccMaskStd, AccCodeXtd, AccMaskXtd);
}

INT32 CANPC_set_acceptance2(USIGN32 AccCodeStd,
                          USIGN32 AccMaskStd,
                          USIGN32 AccCodeXtd,
                          USIGN32 AccMaskXtd)
{
  if(bSingleChannel) { return 0;}
  return CANL2_set_acceptance(ch2.ulChannelHandle, AccCodeStd, AccMaskStd, AccCodeXtd, AccMaskXtd);

}
   
#ifdef EMU
/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_echo_tx_req,CANPC_echo_tx_req2  */
/* FUNCTIONAL_DESCRIPTION         sets the firmware in the mode acknowledging*/
/*                                transmission requests to the host         */
/* INPUTS                         Echo    : 0 = no echo, 1 = echo           */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_echo_tx_req(INT32 Echo)
{
  channel[0].pfct->index = FCT_ECHO_TX_REQ;
  channel[0].pfct->param_1 = Echo;
  channel[0].pfct->host_access = FALSE_;
  if (wait_for_handshake(&channel[0].pfct->host_access, 1L,0)!=OK_)
    return (ERROR4);
  return (channel[0].pfct->return_value);
}
INT32 CANPC_echo_tx_req2(INT32 Echo)
{
    
  if(bSingleChannel) { return 0; }


  channel[0].pfct->index = FCT_ECHO_TX_REQ2;
  channel[0].pfct->param_1 = Echo;
  channel[0].pfct->host_access = FALSE_;
  if (wait_for_handshake(&channel[0].pfct->host_access, 1L,0)!=OK_)
    return (ERROR4);
  return (channel[0].pfct->return_value);
}
#endif //EMU 
   
   
   
/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_set_output_control,                 */
/*                                CANPC_set_output_control2                 */
/* FUNCTIONAL_DESCRIPTION         writes input/output control register of   */
/*                                CAN controller                            */
/* INPUTS                         OutputControl:   [0..FF]                  */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_set_output_control(INT32 OutputControl)
{
  return CANL2_set_output_control(ch1.ulChannelHandle, OutputControl);

}
INT32 CANPC_set_output_control2(INT32 OutputControl)
{
  if(bSingleChannel) { return 0;}
  return CANL2_set_output_control(ch2.ulChannelHandle, OutputControl);
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_start_chip,CANPC_start_chip2        */
/* FUNCTIONAL_DESCRIPTION         changing the firmware mode from initializ.*/
/*                                to online                                 */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_start_chip(void)
{
  INT32 ret;
  
  ret = CANL2_start_chip(ch1.ulChannelHandle);
  if(ret) return ret;
  if(bSingleChannel) { return 0;}
  ret = CANL2_start_chip(ch2.ulChannelHandle);
  
  return (ret);
}

/*
INT32 CANPC_set_interrupt_event(HANDLE hEvent)
{
  INT32 RetCode;
  
  
  RetCode = CANL2_set_interrupt_event(ch1.ulChannelHandle, hEvent);
  if(RetCode) return RetCode;
  if(bSingleChannel) { return 0;}
  RetCode = CANL2_set_interrupt_event(ch2.ulChannelHandle, hEvent);
  
  return RetCode;
}
*/


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_enable_timestamps                   */
/* FUNCTIONAL_DESCRIPTION         dummy                                     */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                        */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_enable_timestamps(void)
{
  return (OK_);
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_enable_fifo_transmit_ack,           */
/*                                CANPC_enable_fifo_transmit_ack2           */
/* FUNCTIONAL_DESCRIPTION         enables transmit interrupts and messages  */
/*                                to host                                   */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_enable_fifo_transmit_ack(void)
{
  return CANL2_enable_fifo_transmit_ack(ch1.ulChannelHandle);
}
INT32 CANPC_enable_fifo_transmit_ack2(void)
{
  
  if(bSingleChannel) { return 0; }

  return CANL2_enable_fifo_transmit_ack(ch2.ulChannelHandle);
}

#ifdef WITH_LOWSPEED
/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_init_signals                        */
/* FUNCTIONAL_DESCRIPTION         init C165 ports for piggyback triggering  */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR1    Signal initialized/             */
/*                                          no initialisation possible      */
/*                                ERROR2    input-only signal was tried to  */
/*                                          initialize as output            */
/*                                ERROR4    timeout of firmware             */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/

INT32 CANPC_init_signals (USIGN32 ulChannelDirectionMask,
                        USIGN32 ulChannelOutputDefaults)
{

  INT32 retCode;
  
  retCode = CANL2_init_signals(
      ch1.ulChannelHandle, 
  ulChannelDirectionMask, 
  ulChannelOutputDefaults
                              );

  if(retCode) return retCode;
  
  if(bSingleChannel) { return 0; }

  retCode = CANL2_init_signals(
      ch2.ulChannelHandle, 
  ulChannelDirectionMask, 
  ulChannelOutputDefaults
                              );
  
  return retCode;
  
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_read_signals                        */
/* FUNCTIONAL_DESCRIPTION         read C165 ports of piggyback triggering   */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR4    timeout of firmware             */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/

INT32 CANPC_read_signals (USIGN32 * pulChannelRead)
{
  INT32 retCode;
  USIGN32 signals;

  
  retCode = CANL2_read_signals(ch1.ulChannelHandle, &signals);
  if(retCode) return retCode;

  
  
  if(bSingleChannel)
  {
    *pulChannelRead = signals;
  }
  else
  {
    *pulChannelRead = 0;
    retCode = CANL2_read_signals(ch2.ulChannelHandle, pulChannelRead);
    *pulChannelRead = ((signals << 8) | (*pulChannelRead & 0xFF));
  }
  
  return retCode;


}





/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_write_signals                       */
/* FUNCTIONAL_DESCRIPTION         write to C165 ports for piggyback         */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_       acknownledged by firmware       */
/*                                ERROR2    input-only signal was tried to  */
/*                                          write like an output            */
/*                                ERROR4    timeout of firmware             */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/

INT32 CANPC_write_signals (USIGN32 ulChannelWrite, USIGN32 ulCareMask)
{
  INT32 retCode;
  
  retCode = CANL2_write_signals(ch1.ulChannelHandle, ulChannelWrite & 0xFF, ulCareMask & 0xFF);
  if(retCode) return retCode;
  
  if(bSingleChannel) { return 0;}

  retCode = CANL2_write_signals(ch2.ulChannelHandle, (ulChannelWrite >> 8) & 0xFF, (ulCareMask >> 8) & 0xFF);
  
  return retCode;
}
#endif // WITH_LOWSPEED


#ifndef EMU
/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_optimize_rcv_speed                  */
/* FUNCTIONAL_DESCRIPTION         dummy                                     */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                       */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_optimize_rcv_speed(void)
{
  return (OK_);
}

#if 0
/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_enable_dde_check                    */
/* FUNCTIONAL_DESCRIPTION         enables check for dde license in          */
/*                                reset_chip                                */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_enable_dde_check(USIGN32 code)
{
  
  CANPC_reinitialize();
  CANPC_synch_communication();
  channel[0].pfct->index = FCT_ENABLE_DDE_CHECK;
  channel[0].pfct->param_1 = (uns_int)(code >>  0);
  channel[0].pfct->param_2 = (uns_int)(code >> 16);
  channel[0].pfct->host_access = FALSE_;
  if (wait_for_handshake(&channel[0].pfct->host_access, 3L,0)!=OK_)
    return (ERROR4);
  return (channel[0].pfct->return_value);
  
}

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_enable_j1939_check                  */
/* FUNCTIONAL_DESCRIPTION         enables check for j1939 license in        */
/*                                reset_chip                                */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_enable_j1939_check(USIGN32 code)
{
  CANPC_reinitialize();
  CANPC_synch_communication();
  channel[0].pfct->index = FCT_ENABLE_J1939_CHECK;
  channel[0].pfct->param_1 = (uns_int)(code >>  0);
  channel[0].pfct->param_2 = (uns_int)(code >> 16);
  channel[0].pfct->host_access = FALSE_;
  if (wait_for_handshake(&channel[0].pfct->host_access, 3L,0)!=OK_)
    return (ERROR4);
  return (channel[0].pfct->return_value);
}

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_enable_ivm_check                    */
/* FUNCTIONAL_DESCRIPTION         enables check for ivm license in          */
/*                                reset_chip                                */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_enable_ivm_check(USIGN32 code)
{
  CANPC_reinitialize();
  CANPC_synch_communication();
  channel[0].pfct->index = FCT_ENABLE_IVM_CHECK;
  channel[0].pfct->param_1 = (uns_int)(code >>  0);
  channel[0].pfct->param_2 = (uns_int)(code >> 16);
  channel[0].pfct->host_access = FALSE_;
  if (wait_for_handshake(&channel[0].pfct->host_access, 3L,0)!=OK_)
    return (ERROR4);
  return (channel[0].pfct->return_value);
}
#endif //0
#endif //not EMU


#ifndef EMU


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_set_rcv_fifo_size                   */
/* FUNCTIONAL_DESCRIPTION                                                   */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                       */
/*                                                                          */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_set_rcv_fifo_size(INT32 size)
{
  INT32 ret = 0;

  /*
  ret = CANL2_set_rcv_fifo_size(ch1.ulChannelHandle, size);
  if(bSingleChannel) { return ret; }
  ret = CANL2_set_rcv_fifo_size(ch2.ulChannelHandle, size);
  */

  return ret;
}

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       INIPC_close_board                         */
/* FUNCTIONAL_DESCRIPTION         closes and frees C&S ressources           */
/* CHANGES                                                                  */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 INIPC_close_board(void)  
{
  if (boLoadCardSuccessful == TRUE)
  {
    CANPC_reinitialize();
    CANPC_reset_chip();
  }
  
  
  
  INIL2_close_channel(ch1.ulChannelHandle);
  if(!bSingleChannel)
  {
    INIL2_close_channel(ch2.ulChannelHandle);
  }
  memset(&ch1,0,sizeof(CANL2_CH_STRUCT));
  memset(&ch2,0,sizeof(CANL2_CH_STRUCT));
  
  return(OK_);
}

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       INIPC_initialize_board                    */
/* FUNCTIONAL_DESCRIPTION         configuration of hw addresses of dpram    */
/*                                in address area of PC                     */
/* INPUTS                         address                                   */
/* OUTPUTS                        address valid                             */
/* CHANGES                                                                  */
/*                                                                          */
/*HEAD_END*******************************************************************/

INT32 INIPC_initialize_board(CANPC_RESOURCES* pCanCardRessource)
{

  INT32 RetCode = 0, ch_found = 0;


  ch_found = 2;
  strcpy((char*)ch1.sChannelName, "Softing1");
  strcpy((char*)ch2.sChannelName, "Softing2");

 
  RetCode = INIL2_initialize_channel(&ch1.ulChannelHandle, (char*)ch1.sChannelName);

  if(RetCode) return RetCode;

  RetCode = INIL2_initialize_channel(&ch2.ulChannelHandle, (char*)ch2.sChannelName);

  return RetCode;

}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_enable_dyn_obj_buf                  */
/* FUNCTIONAL_DESCRIPTION         enables dynamic object buffer             */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_enable_dyn_obj_buf(void)
{
  INT32 ret;
  
  ret = CANL2_enable_dyn_obj_buf(ch1.ulChannelHandle);
  if(ret) return ret;
  channel[0].dyn_enable = TRUE;

    
  if(bSingleChannel) { return 0; }


  ret = CANL2_enable_dyn_obj_buf(ch2.ulChannelHandle);
  channel[1].dyn_enable = TRUE;
  return ret;
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_enable_fifo                         */
/* FUNCTIONAL_DESCRIPTION         enables fifo mode                         */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_enable_fifo(void)
{
  INT32 ret;
  
  ret = CANL2_enable_fifo(ch1.ulChannelHandle);
  if(ret) return ret;

    
  if(bSingleChannel) { return 0; }


  ret = CANL2_enable_fifo(ch2.ulChannelHandle);
  
  return ret;
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_enable_error_frame_detection        */
/* FUNCTIONAL_DESCRIPTION         enables signalling of single error frames */
/* INPUTS                         -                                         */
/* OUTPUTS                        OK_                                       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_enable_error_frame_detection(void)
{
  INT32 ret;
  
  ret = CANL2_enable_error_frame_detection(ch1.ulChannelHandle);
  if(ret) return ret;

    
  if(bSingleChannel) { return 0; }


  ret = CANL2_enable_error_frame_detection(ch2.ulChannelHandle);
  
  return ret;
}




/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_initialize_interface                */
/* FUNCTIONAL_DESCRIPTION         defines modes for object buffer           */
/* INPUTS                         ReceiveFifoEnable:  signal fifo or poll   */
/*                                   rcv objects                            */
/*                                ReceivePollAll:  poll all std objects     */
/*                                   or only defined ones                   */
/*                                ReceiveEnableAll:  enable all std rcv objs*/
/*                                ReceiveIntEnableAll:  signal all std rcv  */
/*                                   object messages                        */
/*                                AutoRemoteEnable: automatic retransmission*/
/*                                   of a data frame after remote frame     */
/*                                   reception                              */
/*                                TransmitReqFifoEnable: signal fifo or poll*/
/*                                   xmt objects                            */
/*                                TransmitPollAll: poll all xmt objects     */
/*                                   or only defined ones                   */
/*                                TransmitAckEnableAll:  signal transmitted */
/*                                   objects                                */
/*                                TransmitAckFifoEnableAll:  signal fifo    */
/*                                   or poll acks                           */
/*                                TransmitRmtFifoEnableAll:  fifo for remote*/
/*                                   answeres or poll                       */
/* OUTPUTS                        OK_                                       */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_initialize_interface(INT32 ReceiveFifoEnable,
                               INT32 ReceivePollAll,
                               INT32 ReceiveEnableAll,
                               INT32 ReceiveIntEnableAll,
                               INT32 AutoRemoteEnableAll,
                               INT32 TransmitReqFifoEnable,
                               INT32 TransmitPollAll,
                               INT32 TransmitAckEnableAll,
                               INT32 TransmitAckFifoEnableAll,
                               INT32 TransmitRmtFifoEnableAll)
{
  INT32 ret;
  
  ret = CANL2_initialize_interface(
      ch1.ulChannelHandle,
  ReceiveFifoEnable,
  ReceivePollAll,
  ReceiveEnableAll,
  ReceiveIntEnableAll,
  AutoRemoteEnableAll,
  TransmitReqFifoEnable,
  TransmitPollAll,
  TransmitAckEnableAll,
  TransmitAckFifoEnableAll,
  TransmitRmtFifoEnableAll);
  if(ret) return ret;
    
  if(bSingleChannel) { return 0; }


  if(channel[1].dyn_enable)
  {
    ret = CANL2_initialize_interface(
        ch2.ulChannelHandle,
    ReceiveFifoEnable,
    ReceivePollAll,
    ReceiveEnableAll,
    ReceiveIntEnableAll,
    AutoRemoteEnableAll,
    TransmitReqFifoEnable,
    TransmitPollAll,
    TransmitAckEnableAll,
    TransmitAckFifoEnableAll,
    TransmitRmtFifoEnableAll);
  }
  else
  {  // static object buffer on channel 0, fifo mode on channel 1
    CANL2_enable_fifo(ch2.ulChannelHandle);
  }
  
  return (ret);
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_define_object, CANPC_define_object2 */
/* FUNCTIONAL_DESCRIPTION         definition of an objekts and modes        */
/* INPUTS                         Ident:    Identifier                      */
/*                                Type:     Transferdirection    0: read    */
/*                                                               1: write   */
/*                                ReceiveIntEnable: generation  of a signal */
/*                                   to the PC after a frame reception      */
/*                                AutoRemoteEnable: automatic retransmission*/
/*                                   of a data frame after remote frame     */
/*                                   reception                              */
/*                                TransmitAckEnable: generation of a signal */
/*                                   to the PC after transmission of a frame*/
/* OUTPUTS                        OK_                                       */
/*                                ERROR1   parameter  error                 */
/*                                ERROR2   dynamic object buffer not enabled*/
/*                                ERROR4   too many objects already defined */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_define_object (USIGN32 Ident,
                         PINT32 ObjectNumber,
                         INT32 Type,
                         INT32 ReceiveIntEnable,
                         INT32 AutoRemoteEnable,
                         INT32 TransmitAckEnable)
{

  return CANL2_define_object (ch1.ulChannelHandle, Ident, ObjectNumber, Type,ReceiveIntEnable,AutoRemoteEnable,TransmitAckEnable);
}

INT32 CANPC_define_object2(USIGN32 Ident,
                         PINT32 ObjectNumber,
                         INT32 Type,
                         INT32 ReceiveIntEnable,
                         INT32 AutoRemoteEnable,
                         INT32 TransmitAckEnable)
{
  
  if(bSingleChannel) { return 0; }

  return CANL2_define_object (ch2.ulChannelHandle, Ident, ObjectNumber, Type,ReceiveIntEnable,AutoRemoteEnable,TransmitAckEnable);

}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_define_cyclic, CANPC_define_cyclic2 */
/* FUNCTIONAL_DESCRIPTION         defines cyclic transmission of objects    */
/* INPUTS                         ObjectNumber, Rate in ms, limit of cycles */
/* OUTPUTS                        OK_                                       */
/*                                ERROR1   object number not valid          */
/*                                ERROR4    timeout of firmware             */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_define_cyclic (INT32          ObjectNumber,
                         USIGN32 Rate,
                         USIGN32 Cycles)
{
  return CANL2_define_cyclic(ch1.ulChannelHandle, ObjectNumber, Rate, Cycles);
}

INT32 CANPC_define_cyclic2(INT32          ObjectNumber,
                         USIGN32 Rate,
                         USIGN32 Cycles)
{
  
  if(bSingleChannel) { return 0; }

  return CANL2_define_cyclic(ch2.ulChannelHandle, ObjectNumber, Rate, Cycles);
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       send_remote_object,send remote_object2    */
/* FUNCTIONAL_DESCRIPTION         transmits a remote frame                  */
/* INPUTS                         Ident:     object number                  */
/*                                DataLength: dlc in remote frame           */
/* OUTPUTS                        OK                                       */
/*                                ERROR1: last request still pending        */
/*                                ERROR3: fifo full                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_send_remote_object(INT32 Ident, INT32 DataLength)
{
  return CANL2_send_remote_object(ch1.ulChannelHandle, Ident, DataLength);
}

INT32 CANPC_send_remote_object2(INT32 Ident, INT32 DataLength)
{
  if(bSingleChannel) { return 0;}
  return CANL2_send_remote_object(ch2.ulChannelHandle, Ident, DataLength);
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       supply_object_data,supply_object_data2    */
/* FUNCTIONAL_DESCRIPTION         writes data into xmt object buffer without*/
/*                                transmitting a frame                      */
/* INPUTS                         Ident:     object number                  */
/*                                DataLength:number of xmt data bytes       */
/*                                pData:     pointer to data                */
/* OUTPUTS                        OK                                       */
/*                                ERROR1: last request still pending        */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_supply_object_data(INT32 Ident, INT32 DataLength, PUSIGN8 pData)
{

  return CANL2_supply_object_data(ch1.ulChannelHandle, Ident, DataLength, pData);
}

INT32 CANPC_supply_object_data2(INT32 Ident, INT32 DataLength, PUSIGN8 pData)
{
  if(bSingleChannel) { return 0;}
  return CANL2_supply_object_data(ch2.ulChannelHandle, Ident, DataLength, pData);
}





/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                    supply_rcv_object_data,supply_rcv_obect_data2*/
/* FUNCTIONAL_DESCRIPTION      initializes rcv object data                  */
/* INPUTS                      Ident:     object number                     */
/*                             DataLength:dummy                             */
/*                             pData:     pointer to array of data          */
/* OUTPUTS                     OK                                           */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_supply_rcv_object_data(INT32 Ident, INT32 DataLength, PUSIGN8 pData)
{
  return CANL2_supply_rcv_object_data(ch1.ulChannelHandle, Ident,  DataLength,  pData);

}

INT32 CANPC_supply_rcv_object_data2(INT32 Ident, INT32 DataLength, PUSIGN8 pData)
{
  if(bSingleChannel) { return 0;}
  return CANL2_supply_rcv_object_data(ch2.ulChannelHandle, Ident,  DataLength,  pData);
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       send_object,send_object2                  */
/* FUNCTIONAL_DESCRIPTION         transmits data previously written in      */
/*                                object buffer by supply_object_data or    */
/*                                write_object                              */
/* INPUTS                         Ident:      Identifier                    */
/*                                DataLength: number of transmit data       */
/* OUTPUTS                        OK                                        */
/*                                ERROR1: request overrun                   */
/*                                ERROR3: fifo full                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_send_object(INT32 Ident, INT32 DataLength)
{

  return CANL2_send_object(ch1.ulChannelHandle, Ident, DataLength);

}

INT32 CANPC_send_object2(INT32 Ident, INT32 DataLength)
{
  if(bSingleChannel) { return 0;}
  return CANL2_send_object(ch2.ulChannelHandle, Ident, DataLength);
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       write_object, write_object2               */
/* FUNCTIONAL_DESCRIPTION         writes data in object buffer and requests */
/*                                data frame for transmission               */
/* INPUTS                         Ident:     Identifier                     */
/*                                DataLength:number of data bytes           */
/*                                *pData:    pointer to data                */
/* OUTPUTS                        OK                                        */
/*                                ERROR1: request overrun                   */
/*                                ERROR3: fifo full                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_write_object(INT32 Ident, INT32 DataLength, PUSIGN8 pData)
{
  return CANL2_write_object(ch1.ulChannelHandle, Ident, DataLength, pData);
}

INT32 CANPC_write_object2(INT32 Ident, INT32 DataLength, PUSIGN8 pData)
{
  if(bSingleChannel) { return 0;}
  return CANL2_write_object(ch2.ulChannelHandle, Ident, DataLength, pData);
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       read_rcv_data, read_rcv_data2             */
/* FUNCTIONAL_DESCRIPTION         reads received data from object buffer    */
/* INPUTS                         Ident:     Identifier                     */
/*                                *pRCV_Data:pointer to data                */
/* OUTPUTS                        RET_CODE0: no new data received           */
/*                                RET_CODE1: data frame received            */
/*                                RET_CODE2: remote frame received          */
/*                                ERROR1:    overrun in object buffer by    */
/*                                           data frame                     */
/*                                ERROR2:    overrun in object buffer by    */
/*                                           remote frame                   */
/*                                ERROR3:    object not defined             */
/*                                ERROR7:    timeout in access to receive   */
/*                                           object                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_read_rcv_data(INT32 Ident, PUSIGN8 pData, PUSIGN32 Time)
{

  return CANL2_read_rcv_data(ch1.ulChannelHandle, Ident, pData, Time);
}

INT32 CANPC_read_rcv_data2(INT32 Ident, PUSIGN8 pData, PUSIGN32 Time)
{
  if(bSingleChannel) { return 0; }

  return CANL2_read_rcv_data(ch2.ulChannelHandle, Ident, pData, Time);
}

#ifdef DTS
/* enhanced read_rcv_data function */
/* returns now also the datalength */
/* ------------------------------- */ 

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       read_rcv_data_e, read_rcv_data_e2         */
/* FUNCTIONAL_DESCRIPTION         reads received data from object buffer    */
/* INPUTS                         Ident:      Identifier                    */
/*                                pDataLength:pointer to data length        */
/*                                *pRCV_Data: pointer to data               */
/*                                Time:       pointer to time               */
/*                                                                          */
/* OUTPUTS                        RET_CODE0: no new data received           */
/*                                RET_CODE1: data frame received            */
/*                                RET_CODE2: remote frame received          */
/*                                ERROR1:    overrun in object buffer by    */
/*                                           data frame                     */
/*                                ERROR2:    overrun in object buffer by    */
/*                                           remote frame                   */
/*                                ERROR3:    object not defined             */
/*                                ERROR7:    timeout in access to receive   */
/*                                           object                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_read_rcv_data_e(INT32 Ident, PINT32 pDataLength,
                          PUSIGN8 pData, PUSIGN32 Time)
{
  channel[0].pfct->index = FCT_READ_RCV_DATA_E;
  channel[0].pfct->param_1 = Ident;
  channel[0].pfct->host_access = FALSE_;
  if (wait_for_handshake(&channel[0].pfct->host_access, 3L,0)!=OK_)
    return (ERROR4);
  
  *pDataLength = channel[0].pfct->param_2;
  *(PUSIGN32)&(pData[0]) = *(PUSIGN32)&(channel[0].pfct->param_3);
  *(PUSIGN32)&(pData[4]) = *(PUSIGN32)&(channel[0].pfct->param_5);
  *Time = *(PUSIGN32)&(channel[0].pfct->param_7);
  return (channel[0].pfct->return_value);
}

INT32 CANPC_read_rcv_data_e2(INT32 Ident, PINT32 pDataLength,
                           PUSIGN8 pData, PUSIGN32 Time)
{
  channel[1].pfct->index = FCT_READ_RCV_DATA_E2;
  channel[1].pfct->param_1 = Ident;
  channel[1].pfct->host_access = FALSE_;
  if (wait_for_handshake(&channel[1].pfct->host_access, 3L,0)!=OK_)
    return (ERROR4);
  
  *pDataLength = channel[1].pfct->param_2;
  *(PUSIGN32)&(pData[0]) = *(PUSIGN32)&(channel[1].pfct->param_3);
  *(PUSIGN32)&(pData[4]) = *(PUSIGN32)&(channel[1].pfct->param_5);
  *Time = *(PUSIGN32)&(channel[1].pfct->param_7);
  return (channel[1].pfct->return_value);
}

#endif /* DTS */



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       read_xmt_data, read_xmt_data2             */
/* FUNCTIONAL_DESCRIPTION         reads transmit object data and checks     */
/*                                transmit acknowledge                      */
/* INPUTS                         Ident:        identifier                  */
/*                                *pDataLength: return of data length       */
/*                                *pXMT_Data:   return of data              */
/* OUTPUTS                        RET_CODE0:    data not yet transmitted    */
/*                                RET_CODE1:    data already transmitted    */
/*                                ERROR1        acknowledge overrun         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_read_xmt_data(INT32 Ident, PINT32 pDataLength, PUSIGN8 pXMTData)
{
  return CANL2_read_xmt_data(ch1.ulChannelHandle, Ident, pDataLength, pXMTData);
}

INT32 CANPC_read_xmt_data2(INT32 Ident, PINT32 pDataLength, PUSIGN8 pXMTData)
{
  if(bSingleChannel) { return 0;}
  return CANL2_read_xmt_data(ch2.ulChannelHandle, Ident, pDataLength, pXMTData);
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_get_bus_state                     */
/* FUNCTIONAL_DESCRIPTION         returns bus state                         */
/*                                                                          */
/* INPUTS                         Can: bus 1 or 2                           */
/* OUTPUTS                        0: error active                           */
/*                                1: error passive                          */
/*                                2: bus off                                */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_get_bus_state(INT32 Can)
{
  if (Can == 1)
    return((INT32)CANL2_get_bus_state(ch1.ulChannelHandle));
  else
  {
      
    if(bSingleChannel) { return 2; }
    return((INT32)CANL2_get_bus_state(ch2.ulChannelHandle));
  }
}



INT32 CANPC_read_ac(param_struct *param)
{
  static INT32 ret1 = 0, ret2 = 0;
  INT32 RetCode = 0;
  static PARAM_STRUCT para1, para2;

    

  if(bSingleChannel) 
  { 
    ret1 = CANL2_read_ac(ch1.ulChannelHandle, &para1);
    memcpy(param, &para1, sizeof(param_struct));
    param->Can = 1;
    param->Time = para1.Time;

    return ret1; 
  }


  pthread_mutex_lock(&mutex);

  if(!ret1)
  {
    ret1 = CANL2_read_ac(ch1.ulChannelHandle, &para1);
  }

  if(!ret2)
  {
    ret2 = CANL2_read_ac(ch2.ulChannelHandle, &para2);
  }
  
  if(ret1 && ret2)
  {
    if(para1.Time > para2.Time)
    {
      RetCode = ret2;
      ret2 = 0;
      memcpy(param, &para2, sizeof(param_struct));
      param->Can = 2;
      param->Time = para2.Time;
    }
    else
    {
      RetCode = ret1;
      ret1 = 0;
      memcpy(param, &para1, sizeof(param_struct));
      param->Can = 1;
      param->Time = para1.Time;
    }
  }
  else
  {
    if(ret1)
    {
      RetCode = ret1;
      ret1 = 0;
      memcpy(param, &para1, sizeof(param_struct));
      param->Can = 1;
      param->Time = para1.Time;
    }

    if(ret2)
    {
      RetCode = ret2;
      ret2 = 0;
      memcpy(param, &para2, sizeof(param_struct));
      param->Can = 2;
      param->Time = para2.Time;
    }
  }
  
  pthread_mutex_unlock(&mutex);
  return RetCode;
  
}


#ifdef DTS

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                      CANPC_send_data_fast, CANPC_send_data_fast2*/
/* FUNCTIONAL_DESCRIPTION        transmit   a data frame                    */
/* INPUTS                        Ident:     Identifier                      */
/*                               DataLength:length of data                  */
/*                               *pData:    pointer to array of data        */
/* OUTPUTS                       0     INT32: ok                              */
/*                               -1    INT32: fifo full                       */
/* CHANGES                       -                                          */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_send_data_fast (USIGN32 Ident,
                          INT32 Xtd,
                          INT32 DataLength,
                          PUSIGN8 pData)
{
  
  register byte volatile far *temp_ptr;
  
  if (fast_fifo[31]){ return(-1);  }  // fifo full
  
  temp_ptr = (unsigned char far*)fast_fifo;
  temp_ptr[1] = (unsigned char)DataLength;
  if (Xtd)
    //extended data frame
    /*| 0   1 | 2   3 | 4   5 | 6   7 | 8   9 | 10  11| 12  13 ... */
    /* CMD LEN IDl IDL IDh IDH  D0  D1  D2  D3  D4  D5  D6  D7 */
  {
    temp_ptr[0] = XMT_CMD_XTD;
    *(PUSIGN32)&temp_ptr[2] = Ident;
    *(PUSIGN32)&temp_ptr[6]  = *(PUSIGN32)&(pData[0]);
    *(PUSIGN32)&temp_ptr[10] = *(PUSIGN32)&(pData[4]);
  }
  else
  {
    //standard data frame
    /*| 0   1 | 2   3 | 4   5 | 6   7 | 8   9 | 10  11| 12 */
    /* CMD LEN IDL IDH XXX  D0  D1  D2  D3  D4  D5  D6  D7 */
    temp_ptr[0] = XMT_CMD;
    *(PUSIGN16)&temp_ptr[2] = (uns_int)Ident;
    *(PUSIGN32)&temp_ptr[5] = *(PUSIGN32)&(pData[0]);
    *(PUSIGN32)&temp_ptr[9] = *(PUSIGN32)&(pData[4]);
  }
  temp_ptr[31]=1;
  return(0);
}

INT32 CANPC_send_data_fast2(USIGN32 Ident,
                          INT32 Xtd,
                          INT32 DataLength,
                          PUSIGN8 pData)
{
  
  register byte volatile far *temp_ptr;
  
  if (fast_fifo[31])
    return(-1);     // fifo full
  
  temp_ptr = (unsigned char far*)fast_fifo;
  temp_ptr[1] = (unsigned char)DataLength;
  if (Xtd)
    //extended data frame
    /*| 0   1 | 2   3 | 4   5 | 6   7 | 8   9 | 10  11| 12  13 */
    /* CMD LEN IDl IDL IDh IDH  D0  D1  D2  D3  D4  D5  D6  D7 */
  {
    temp_ptr[0] = XMT_CMD_XTD2;
   
    *(PUSIGN32)&temp_ptr[2] = Ident;
    *(PUSIGN32)&temp_ptr[6]  = *(PUSIGN32)&(pData[0]);
    *(PUSIGN32)&temp_ptr[10] = *(PUSIGN32)&(pData[4]);
  
  }
  else
  {
    //standard data frame
    /*| 0   1 | 2   3 | 4   5 | 6   7 | 8   9 | 10  11| 12 */
    /* CMD LEN IDL IDH XXX  D0  D1  D2  D3  D4  D5  D6  D7 */
    temp_ptr[0] = XMT_CMD2;
    
    *(PUSIGN16)&temp_ptr[2] = (uns_int)Ident;
    
    *(PUSIGN32)&temp_ptr[5] = *(PUSIGN32)&(pData[0]);
    *(PUSIGN32)&temp_ptr[9] = *(PUSIGN32)&(pData[4]);
  }
  fast_fifo[31]=1;
  return(0);
}

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_send_remote, send_remote2         */
/* FUNCTIONAL_DESCRIPTION         transmit   a data frame                   */
/* INPUTS                         Ident:     Identifier                     */
/*                                DataLength: dlc code in remote frame      */
/* OUTPUTS                        0     INT32: ok                             */
/*                                -1    INT32: fifo full                      */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_send_remote_fast (USIGN32 Ident, INT32 Xtd, INT32 DataLength)
{
  
  register byte volatile far *temp_ptr;
  
  if (fast_fifo[31])
    return(-1);     // fifo full
  
  temp_ptr = (unsigned char far*)fast_fifo;
  temp_ptr[1] = (unsigned char)DataLength;
  if (Xtd)
    //extended remote frame
    /*| 0   1 | 2   3 | 4   5  */
    /* CMD LEN IDl IDL IDh IDH */
  {
    temp_ptr[0] = XMT_CMD_XTD_RMT;
    
    *(PUSIGN32)&temp_ptr[2] = Ident;
  
  }
  else
  {
    //standard remote frame
    /*| 0   1 | 2   3  */
    /* CMD LEN IDL IDH */
    temp_ptr[0] = XMT_CMD_RMT;
    
    *(PUSIGN16)&temp_ptr[2] = (uns_int)Ident;
  
  }
  fast_fifo[31]=1;
  return(0);
}

INT32 CANPC_send_remote_fast2(USIGN32 Ident, INT32 Xtd, INT32 DataLength)
{
  
  register byte volatile far *temp_ptr;
  
  if (fast_fifo[31])
    return(-1);     // fifo full
  
  temp_ptr = (unsigned char far*)fast_fifo;
  temp_ptr[1] = (unsigned char)DataLength;
  if (Xtd)
    //extended remote frame
    /*| 0   1 | 2   3 | 4   5  */
    /* CMD LEN IDl IDL IDh IDH */
  {
    temp_ptr[0] = XMT_CMD_XTD_RMT2;
    *(PUSIGN32)&temp_ptr[2] = Ident;
  }
  else
  {
    //standard remote frame
    /*| 0   1 | 2   3  */
    /* CMD LEN IDL IDH */
    temp_ptr[0] = XMT_CMD_RMT2;
    *(PUSIGN16)&temp_ptr[2] = (uns_int)Ident;
  }
  fast_fifo[31]=1;
  return(0);
}

INT32 CANPC_send_error_frame(void)
{
  
  
  if (fast_fifo[31])
    return(-1);     // fifo full
  
  fast_fifo[0]=ERR_CMD; //#define ERR_CMD                 0x10
  fast_fifo[31]=1;
  return(0);
}

INT32 CANPC_send_error_frame2(void)
{
  
  
  if (fast_fifo[31])
    return(-1);     // fifo full
  
  fast_fifo[0] = (unsigned char) (ERR_CMD2); //#define ERR_CMD2 0x10 | 0x80
  fast_fifo[31] = (unsigned char)1;
  return(0);
}

#endif // DTS


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_send_data, CANPC_send_data2     */
/* FUNCTIONAL_DESCRIPTION         transmit   a data frame                   */
/* INPUTS                         Ident:     Identifier                     */
/*                                DataLength:length of data                 */
/*                                *pData:    pointer to array of data       */
/* OUTPUTS                        0     INT32: ok                             */
/*                                -1    INT32: fifo full                      */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_send_data (USIGN32 Ident,
                     INT32 Xtd,
                     INT32 DataLength,
                     PUSIGN8 pData)
{
  return CANL2_send_data (ch1.ulChannelHandle, Ident,Xtd,DataLength,pData);
}

INT32 CANPC_send_data2(USIGN32 Ident,
                     INT32 Xtd,
                     INT32 DataLength,
                     PUSIGN8 pData)
{
  if(bSingleChannel) { return 0;}
  return CANL2_send_data (ch2.ulChannelHandle, Ident,Xtd,DataLength,pData);

}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_send_remote, send_remote2         */
/* FUNCTIONAL_DESCRIPTION         transmit   a data frame                   */
/* INPUTS                         Ident:     Identifier                     */
/*                                DataLength: dlc code in remote frame      */
/* OUTPUTS                        0     INT32: ok                             */
/*                                -1    INT32: fifo full                      */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_send_remote (USIGN32 Ident, INT32 Xtd, INT32 DataLength)
{
  return CANL2_send_remote (ch1.ulChannelHandle, Ident, Xtd, DataLength);
}

INT32 CANPC_send_remote2(USIGN32 Ident, INT32 Xtd, INT32 DataLength)
{
  if(bSingleChannel) { return 0;}
  return CANL2_send_remote (ch2.ulChannelHandle, Ident, Xtd, DataLength);

}
   
   /*HEAD_BEG*******************************************************************/
   /*                                                                          */
   /* FUNCTION                       CANPC_set_trigger,   CANPC_set_trigger2   */
   /* FUNCTIONAL_DESCRIPTION         controls trigger outputs                  */
   /* INPUTS                         level:     output level                   */
   /* OUTPUTS                        0     INT32: ok                             */
   /*                                -1    INT32: fifo full                      */
   /* CHANGES                        -                                         */
   /*                                                                          */
   /*HEAD_END*******************************************************************/

INT32 CANPC_set_trigger (INT32 level)
{

  return(0);
}


INT32 CANPC_set_trigger2(INT32 level)
{
 
  return(0);
}
   
INT32 CANPC_get_time(PUSIGN32 time)
{
  return CANL2_get_time(ch1.ulChannelHandle,time);
}
   
   

/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_reset_xmt_fifo                      */
/* FUNCTIONAL_DESCRIPTION         resets transmit fifo                      */
/* INPUTS                         -                                         */
/* OUTPUTS                        0     INT32: no error                       */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/

INT32 CANPC_reset_xmt_fifo(void)
{
  
  CANL2_reset_xmt_fifo(ch1.ulChannelHandle);
  if(bSingleChannel) { return 0;}
  CANL2_reset_xmt_fifo(ch2.ulChannelHandle);
  
  return (0);
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANL2_read_rcv_fifo_level                 */
/* FUNCTIONAL_DESCRIPTION         returns items in receive fifo             */
/* INPUTS                         -                                         */
/* OUTPUTS                        items in receive fifo                     */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_read_rcv_fifo_level(void)
{
  if(bSingleChannel) { return CANL2_read_rcv_fifo_level(ch1.ulChannelHandle); }

  return (CANL2_read_rcv_fifo_level(ch1.ulChannelHandle)+CANL2_read_rcv_fifo_level(ch2.ulChannelHandle));
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANL2_read_rcv_fifo_level                 */
/* FUNCTIONAL_DESCRIPTION         returns items in receive fifo             */
/* INPUTS                         -                                         */
/* OUTPUTS                        items in receive fifo                     */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_read_xmt_fifo_level(void)
{
  
  return (CANL2_read_xmt_fifo_level(ch1.ulChannelHandle)+CANL2_read_xmt_fifo_level(ch2.ulChannelHandle));
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_reset_lost_msg_counter              */
/* FUNCTIONAL_DESCRIPTION         resets lost msg counter                   */
/* INPUTS                         -                                         */
/* OUTPUTS                        0     INT32: no error                       */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_reset_lost_msg_counter(void)
{
  CANL2_reset_lost_msg_counter(ch1.ulChannelHandle);
  if(bSingleChannel) { return 0;}
  CANL2_reset_lost_msg_counter(ch2.ulChannelHandle);
  return(0);
}



/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_get_trigger                         */
/* FUNCTIONAL_DESCRIPTION         dummy function                            */
/* INPUTS                         -                                         */
/* OUTPUTS                        0     INT32: no error                       */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
#ifdef __BORLANDC__
#pragma argsused
#endif
INT32 CANPC_get_trigger (INT32 * level)
{
  return(OK_);
}


/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_get_trigger2                        */
/* FUNCTIONAL_DESCRIPTION         dummy function                            */
/* INPUTS                         -                                         */
/* OUTPUTS                        0     INT32: no error                       */
/* CHANGES                        -                                         */
/*                                                                          */
/*HEAD_END*******************************************************************/
#ifdef __BORLANDC__
#pragma argsused
#endif
INT32 CANPC_get_trigger2 (INT32 * level)
{
  return(OK_);
}


#ifdef OBJECT_FILTER
/*HEAD_BEG*******************************************************************/
/*                                                                          */
/* FUNCTION                       CANPC_object_filter                       */
/* FUNCTIONAL_DESCRIPTION         defines a input filter for a received     */
/*                                message which is defined in the object    */
/*                                buffer                                    */
/*                                                                          */
/* INPUTS                         Ident:     object number                  */
/*                                nFrames:   number of frames after which a */
/*                                           message is passed to the API   */
/*                                           if the received data are not   */
/*                                           changed                        */
/*                                pData:     pointer to data filter         */
/* OUTPUTS                        OK                                        */
/*                                ERROR1:    parameter error                */
/*                                ERROR4:    timeout error                  */
/*                                                                          */
/*HEAD_END*******************************************************************/
INT32 CANPC_object_filter(INT32 Ident, USIGN32 nFrames, PUSIGN8 pData)
{
  channel[0].pfct->index = FCT_OBJECT_FILTER;
  /* check for wrong objectnumber */
  if((Ident<0) || (Ident>199))
    return (ERROR1);
  channel[0].pfct->param_1 = Ident;
  channel[0].pfct->param_2 = nFrames;
  *(PUSIGN32)&(channel[0].pfct->param_3) = *(PUSIGN32)&(pData[0]);
  *(PUSIGN32)&(channel[0].pfct->param_5) = *(PUSIGN32)&(pData[4]);
  channel[0].pfct->host_access = FALSE_;
  if (wait_for_handshake(&channel[0].pfct->host_access, 3L,0)!=OK_)
    return (ERROR4);
  return (channel[0].pfct->return_value);
}
#endif // OBJECT_FILTER

#endif //not EMU




